<?php
/***********************************************************************************
*  admin_images.php                        Wagner Database Solutions, Inc.
*    v1.06 - 6 Sep 2004  (c) 2004 Steve Wagner.  All rights reserved.
*            See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Screen to maintain the IMAGES table.
* 
*  Notes: 
*    1. The PHP funtion fix() is in include/header_admin.php.
*    2. The Javascript function populate()is in include/header_admin.php.
*
*  Change Log:
*    v1.0   Initial beta release (2/22/2004)
*    v1.01   Added ability to call this screen for Details and only display images related
*           to that specimen.  Added select list for image type. (2/23/2004)
*    v1.02  Changed "key" note. (3/4/04)
*    v1.03  Added urlencode() around specimen # for Netscape (3/7/04)
*    v1.04  Added Image types 1, 2, 3.  Expanded select list description for image_type.
*           Also, added "fossil_images/" as default path for image_loc.  (8/24/04)
*    v1.05  Added rtrim() around fields (8/28/04)
*    v1.06  Added image upload capability from local PC (9/6/04)
*
************************************************************************************/
include_once ("./vdaemon/vdaemon.php");
$header='ADMIN';
include_once ("./include/config.php");
include_once ("./include/header.php");
include_once ("./include/header_admin.php");

?>
<html><body>
<head>
<script language="JavaScript" type="text/JavaScript">
<!--
function image_window_popup (winName, theVars) {
  var features = 'scrollbars=yes,resizable=yes,menubar=yes,location=yes,toolbar=yes,directories=yes';
  var theURL = theVars + '';
  newwindow = window.open (theURL, winName, features);
  if (window.focus) {newwindow.focus()}
  return false;
}
//-->
</script>
</head>
<center><b><font class=pch>Images Administration</font></b><br><br>
Note: If you add/change database references to images, they must be placed<br> in the PaleoCollaborator fossil_images directory (see "Upload Fossil Image" button).</center><br>

<!-- This form is a fake form to call if user wants to get out of insert/update and get new record. --> 
<form method="POST" name="NoVal" action="admin_images.php"></form>

<?php

//print "morphotype_nbr: [" .$morphotype_nbr. "], specimen: [" .$specimen_nbr . "], image type: [" .$image_type . "]  Action: " . $_POST["insert"] . $_POST["gotoinsert"] . $_POST["update"] . $_POST["clear"] . $_POST["delete"] . "---";

if ( isset($_POST['insert']) or isset($_POST['update']) ) {            // ******************INSERT/UPDATE

  if ( isset($_POST['insert']) ) {
    $nbr = -1;
    $nbr2 = -1;
    $nbr3 = -1;
  } elseif ( isset($_POST['update']) ) {
    $nbr = $_POST["hiddenkey"]; # use saved key field in case user updated it.
    $nbr2 = $_POST["hiddenkey2"]; # use saved key field in case user updated it.
    $nbr3 = $_POST["hiddenkey3"]; # use saved key field in case user updated it.
  }
  $sql = "SELECT * FROM IMAGES WHERE MORPHOTYPE_NBR = '" .$nbr. "' AND SPECIMEN_NBR = '" .$nbr2. "' AND IMAGE_TYPE = '" .$nbr3. "';";  // get record either null or with where clause.
  
  # Select record from database
  $rsx = $db->Execute($sql); # Execute the query for empty record (Insert) or with where (update).
  $record = array(); # Initialize an array

  # Set values for fields in record. Note: field names are case-insensitive.
  $record["Morphotype_Nbr"] = stripslashes($_POST["morphotype_nbr"]);
  $record["Specimen_Nbr"] = stripslashes($_POST["specimen_nbr"]);
  $record["Image_Type"] = stripslashes($_POST["image_type"]);
  $record["Image_Loc"] = stripslashes($_POST["image_loc"]);
  $record["Image_Caption"] = stripslashes($_POST["image_caption"]);
  $record["Image_Credit"] = stripslashes($_POST["image_credit"]);
  $record["Image_Copyright"] = stripslashes($_POST["image_copyright"]);

  if ( isset($_POST['insert']) ) {
    # Pass empty recordset & array with data to insert to GetInsertSQL. Fully formatted insert sql will be returned.
    $insertSQL = $db->GetInsertSQL($rsx, $record);
    if ($db->Execute($insertSQL) === false) { # Insert the record into the database
      print "<BR>sql: " . $insertSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error inserting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully inserted...</font><br>\n";
    }
  } elseif ( isset($_POST['update']) ) {
    # Pass recordset & array with data to update to GetUpdateSQL. Fully formatted update sql will be 
	# returned...with WHERE. If data not changed, no recordset returned
    $updateSQL = $db->GetUpdateSQL($rsx, $record);
	if ( $updateSQL == '') { print $ts.'<font class=errmsg>You did not change any data!</font>'; }
    if ($db->Execute($updateSQL) === false) {
      print "<BR>sql: " . $updateSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error updating record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully updated...</font><br>\n";
    }
  }
} elseif ( isset($_POST['clear'])) {       // ************************************************CLEAR
  $morphotype_nbr = '';
  $specimen_nbr = '';
  $image_type = '';
} elseif ( isset($_POST['delete'])) {       // ************************************************DELETE
  $deleteSQL = "DELETE FROM IMAGES WHERE MORPHOTYPE_NBR='".$_POST["morphotype_nbr"]."' AND SPECIMEN_NBR = '".$_POST["specimen_nbr"]."' AND IMAGE_TYPE = '".$_POST["image_type"]."';";
  if ($db->Execute($deleteSQL) === false) {
    print "<BR>sql: " . $deleteSQL . "<br><br>\n";
    print $ts.'<font class=errmsg>Error deleting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
   } else {
    print $ts."<font class=msg>Record successfully deleted...</font><br>\n";
   }
   $morphotype_nbr = '';
   $specimen_nbr = '';
   $image_type = '';   
}

print "<form method=\"POST\" name=\"AImages\" runat=\"vdaemon\" action=\"admin_images.php\">";
print "<vlsummary class=\"defaultErr\" headertext=\"Error(s) found:\">";

print "<table WIDTH=\"95%\" align=\"center\" border=\"0\" cellpadding=\"5\">";

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or ($morphotype_nbr != '' and $specimen_nbr != '' and $image_type != '' ) ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

if (  $image_type == '' and !isset($_POST['insert']) and !isset($_POST['gotoinsert']) ) {
  $sql =  "SELECT MORPHOTYPE_NBR, SPECIMEN_NBR, IMAGE_TYPE FROM IMAGES ";
  if ( ($morphotype_nbr != '' and $specimen_nbr != '') ) {  # called from Details page, add morph# and spec# to WHERE clause
    $sql .= " WHERE MORPHOTYPE_NBR='" .$morphotype_nbr. "' AND SPECIMEN_NBR='" .$specimen_nbr. "' ";
  }
  $sql .= " ORDER BY MORPHOTYPE_NBR, SPECIMEN_NBR, IMAGE_TYPE ;";
  /************  Select list for IMAGES ***********/
  $rs = $db->Execute($sql);
  if ($rs->EOF) {
    print "<tr valign=top halign=left><td>";
    print "<br><font class=errmsg>Error: IMAGE not found.</font><br></td></tr>";
  } else {
    $select_list = "<select size=\"1\" onChange=\"populate(this.form.MORPH_SPEC_IMAGE, 'admin_images.php?morphotype_nbr=', 'specimen_nbr=', 'image_type=');\" name=\"MORPH_SPEC_IMAGE\"><option></option>";
    while (!$rs->EOF) {
      $select_list .= "<option value=\"" . $rs->fields["MORPHOTYPE_NBR"] . "-----" . urlencode($rs->fields["SPECIMEN_NBR"]) . "-----" . $rs->fields["IMAGE_TYPE"] . "\">" .
	                  $rs->fields["MORPHOTYPE_NBR"] . ", " . $rs->fields["SPECIMEN_NBR"] . ", " . $rs->fields["IMAGE_TYPE"] . "</option>";
      $rs->MoveNext();
    }
    $select_list .= "</select>";
    print "<tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\">Select IMAGE to Update/Delete: " . $select_list . "</td>";
    print "</tr><tr valign=top halign=left><td align=\"center\">- OR -</td></tr><tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\"><input type=\"submit\" name=\"gotoinsert\" value=\"Insert New Record\"" .
	    ">&nbsp;&nbsp;<input type=\"button\" name=\"upload\" value=\"Upload Fossil Image\" onClick=\"javascript: image_window_popup('Upload_Images_from_PC', 'upload_images.php');\">".
        "</td></tr>";
  }
} else {
  if ( isset($_POST['gotoinsert']) ) {
    print " ";
  } else {
    $sql =  "SELECT MORPHOTYPE_NBR, SPECIMEN_NBR, IMAGE_TYPE, IMAGE_LOC, IMAGE_CAPTION, IMAGE_CREDIT, IMAGE_COPYRIGHT FROM IMAGES WHERE MORPHOTYPE_NBR = '" .
           $morphotype_nbr . "' AND SPECIMEN_NBR = '" . $specimen_nbr . "' AND IMAGE_TYPE = '" . $image_type . "';"; 
    $rs = $db->Execute($sql);
  }
  if ($rs->EOF) {

    print "<font class=errmsg>Error: IMAGE [" . $morphotype_nbr . "]/[" . $specimen_nbr . "]/[" . $image_type . "] not found.</font><br>";
  } else {
    /****************************************************/
    //  Determine if posting has already occurred.  Otherwise use data selected from record.
    if (isset($_POST["morphotype_nbr"])) { $x_morphotype_nbr= $_POST["morphotype_nbr"]; } else { $x_morphotype_nbr = rtrim($rs->fields["MORPHOTYPE_NBR"]); }
    if (isset($_POST["specimen_nbr"])) { $x_specimen_nbr = $_POST["specimen_nbr"]; } else { $x_specimen_nbr = rtrim($rs->fields["SPECIMEN_NBR"]); }
    if (isset($_POST["image_type"])) { $x_image_type = $_POST["image_type"]; } else { $x_image_type = rtrim($rs->fields["IMAGE_TYPE"]); }
    if (isset($_POST["image_loc"])) { $x_image_loc = $_POST["image_loc"]; } else { $x_image_loc = rtrim($rs->fields["IMAGE_LOC"]); }
    if (isset($_POST["image_caption"])) { $x_image_caption = $_POST["image_caption"]; } else { $x_image_caption = rtrim($rs->fields["IMAGE_CAPTION"]); }
    if (isset($_POST["image_credit"])) { $x_image_credit = $_POST["image_credit"]; } else { $x_image_credit = rtrim($rs->fields["IMAGE_CREDIT"]); }
    if (isset($_POST["image_copyright"])) { $x_image_copyright = $_POST["image_copyright"]; } else { $x_image_copyright = rtrim($rs->fields["IMAGE_COPYRIGHT"]); }
	
    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req1\">Morphotype Nbr: [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"morphotype_nbr\" value=\"".fix($x_morphotype_nbr)."\" size=50>";
    print "<vlvalidator name=\"req1\" type=\"required\" control=\"morphotype_nbr\" errmsg=\"Morphotype Nbr required\"></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req2\">Specimen Nbr: [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"specimen_nbr\" value=\"".fix($x_specimen_nbr)."\" size=50>";
    print "<vlvalidator name=\"req2\" type=\"required\" control=\"specimen_nbr\" errmsg=\"Specimen Nbr required\"></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req3\">Image Type: [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<select size=\"1\" name=\"image_type\" ><option SELECTED>" . $x_image_type . 
	   "</option><option value=\"D\">D - Detailed</option><option value=\"DF\">DF - Detailed, Full Size</option><option value=\"T\">" .
	   "T - Thumbnail</option><option value=\"1\">1 - Alternate 1</option><option value=\"2\">2 - Alternate 2</option>" .
	   "<option value=\"3\">3 - Alternate 3</option></select>";
    print "<vlvalidator name=\"req3\" type=\"required\" control=\"image_type\" errmsg=\"Image Type required, must be D, DF, T, 1, 2, 3\"></td></tr>";

    // Set default path for image location.
    if ($x_image_loc == '') {
      $x_image_loc = 'fossil_images/';   
	}

    print $tr.$td1."Image Location: </td>";
    print $td2."<input type=\"text\" name=\"image_loc\" value=\"".fix($x_image_loc)."\" size=90></td></tr>";
	
	print $tr.$td1." </td>";
    print $td2."<input type=\"button\" name=\"upload\" value=\"Upload Fossil Image\" onClick=\"javascript: image_window_popup('Upload_Images_from_PC', 'upload_images.php');\"></td></tr>";

    print $tr.$td1."Image Caption: </td>";
    print $td2."<input type=\"text\" name=\"image_caption\" value=\"".fix($x_image_caption)."\" size=90></td></tr>";

    print $tr.$td1."Image Credit: </td>";
    print $td2."<input type=\"text\" name=\"image_credit\" value=\"".fix($x_image_credit)."\" size=90></td></tr>";

    print $tr.$td1."Image Copyright: </td>";
    print $td2."<input type=\"text\" name=\"image_copyright\" value=\"".fix($x_image_copyright)."\" size=90></td></tr>";

    print $tr."<td COLSPAN=2><br>".
	      "[<font class=defaultErr>key</font>] - Primary key field(s) for this table.</td></tr>";

    ## save original key values in case it is updated.
    print "<input type=\"hidden\" name=\"hiddenkey\" value=\"". $x_morphotype_nbr . "\" size=50>";
    print "<input type=\"hidden\" name=\"hiddenkey2\" value=\"". $x_specimen_nbr . "\" size=50>";
    print "<input type=\"hidden\" name=\"hiddenkey3\" value=\"". $x_image_type . "\" size=2>";

  }
}
if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or ($morphotype_nbr != '' and $specimen_nbr != '' and $image_type != '' ) ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

print "</table></form>";

/****************************************************************************/
include ("./include/footer.php");
?>
</body>
</html>