<?php
/***********************************************************************************
*  admin_locality.php                        Wagner Database Solutions, Inc.
*    v1.04 - 28 Aug 2004  (c) 2004 Steve Wagner.  All rights reserved.
*            See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Screen to maintain the LOCALITIES table.
* 
*  Notes: 
*    1. The PHP funtion fix()) is in include/header_admin.php.
*    2. The Javascript function populate())is in include/header_admin.php.
*
*  Change Log:
*    v1.0   Initial beta release (2/22/2004)
*    v1.01  Added select list for collections_yn. (2/23/2004)
*    v1.02  Removed recorded_by and recorded_date for this version. (2/24/2004)
*    v1.03  Changed "key" note. (3/4/04)
*    v1.04  Added rtrim() around fields (8/28/04)
*
************************************************************************************/
include_once ("./vdaemon/vdaemon.php");
$header='ADMIN';
include_once ("./include/config.php");
include_once ("./include/header.php");
include_once ("./include/header_admin.php");

?>
<html><body><head>
</head>
<center><b><font class=pch>Locality Administration</font></b></center><br>

<!-- This form is a fake form to call if user wants to get out of insert/update and get new record. --> 
<form method="POST" name="NoVal" action="admin_locality.php"></form>

<?php

//print "Loc_nbr: [" .$loc_nbr. "]  Action: " . $_POST["insert"] . $_POST["gotoinsert"] . $_POST["update"] . $_POST["clear"] . $_POST["delete"] . "---";

if ( isset($_POST['insert']) or isset($_POST['update']) ) {            // ******************INSERT/UPDATE

  if ( isset($_POST['insert']) ) {
    $nbr = -1;  
  } elseif ( isset($_POST['update']) ) {
    $nbr = $_POST["hiddenkey"]; # used saved key field in case user updated it.
  }
  $sql = "SELECT * FROM LOCALITIES WHERE loc_nbr = '" .$nbr. "';";  // get record either null or with where clause.
  
  # Select record from database
  $rsx = $db->Execute($sql); # Execute the query for empty record (Insert) or with where (update).
  $record = array(); # Initialize an array

  # Set values for fields in record. Note: field names are case-insensitive.
  $record["Loc_Nbr"] = stripslashes($_POST["loc_nbr"]);
  $record["Loc_Name"] = stripslashes($_POST["loc_name"]);
  $record["Loc_Description"] = stripslashes($_POST["loc_description"]);
  $record["Land_Owner"] = stripslashes($_POST["land_owner"]);
  $record["County"] = stripslashes($_POST["county"]);
  $record["State"] = stripslashes($_POST["state"]);
  $record["Gps"] = stripslashes($_POST["gps"]);
  $record["Map_Reference"] = stripslashes($_POST["map_reference"]);
  $record["Era"] = stripslashes($_POST["era"]);
  $record["Epoch"] = stripslashes($_POST["epoch"]);
  $record["Period"] = stripslashes($_POST["period"]);
  $record["Local_Age"] = stripslashes($_POST["local_age"]);
  $record["Formation_Name"] = stripslashes($_POST["formation_name"]);
  $record["Member_Name"] = stripslashes($_POST["member_name"]);
  $record["Age_Begin"] = stripslashes($_POST["age_begin"]);
  $record["Age_End"] = stripslashes($_POST["age_end"]);
  $record["Age_Estimate"] = stripslashes($_POST["age_estimate"]);
  $record["Taxa"] = stripslashes($_POST["taxa"]);
  $record["Notes"] = stripslashes($_POST["notes"]);
  $record["Collection_YN"] = stripslashes($_POST["collection_yn"]);
// Ver 2  $record["Recorded_By"] = stripslashes($_POST["recorded_by"]); //  NEED TO FIX WITH USERNAME *******************************************************
// Ver 2  $record["Recorded_Date"] = time();

  if ( isset($_POST['insert']) ) {
    # Pass empty recordset & array with data to insert to GetInsertSQL. Fully formatted insert sql will be returned.
    $insertSQL = $db->GetInsertSQL($rsx, $record);
    if ($db->Execute($insertSQL) === false) { # Insert the record into the database
      print "<BR>sql: " . $insertSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error inserting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully inserted...</font><br>\n";
    }
  } elseif ( isset($_POST['update']) ) {
    # Pass recordset & array with data to update to GetUpdateSQL. Fully formatted update sql will be 
	# returned...with WHERE. If data not changed, no recordset returned
    $updateSQL = $db->GetUpdateSQL($rsx, $record);
	if ( $updateSQL == '') { print $ts.'<font class=errmsg>You did not change any data!</font>'; }
    if ($db->Execute($updateSQL) === false) {
      print "<BR>sql: " . $updateSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error updating record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully updated...</font><br>\n";
    }
  }
} elseif ( isset($_POST['clear'])) {       // ************************************************CLEAR
  $loc_nbr = '';
} elseif ( isset($_POST['delete'])) {       // ************************************************DELETE
  $deleteSQL = "DELETE FROM LOCALITIES WHERE LOC_NBR='" .  $_POST["loc_nbr"] . "';";
  if ($db->Execute($deleteSQL) === false) {
    print "<BR>sql: " . $deleteSQL . "<br><br>\n";
    print $ts.'<font class=errmsg>Error deleting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
   } else {
    print $ts."<font class=msg>Record successfully deleted...</font><br>\n";
   }
   $loc_nbr = '';
}

print "<form method=\"POST\" name=\"ALocality\" runat=\"vdaemon\" action=\"admin_locality.php\">";
print "<vlsummary class=\"defaultErr\" headertext=\"Error(s) found:\">";

print "<table WIDTH=\"95%\" align=\"center\" border=\"0\" cellpadding=\"5\">";

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or $loc_nbr != '' ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

if ($loc_nbr == '' and !isset($_POST['insert']) and !isset($_POST['gotoinsert']) ) {
  $sql =  "SELECT LOC_NBR, LOC_NAME, LOC_DESCRIPTION FROM LOCALITIES ORDER BY LOC_NAME;";
  /************  Select list for Localities ***********/
  $rs = $db->Execute($sql);
  if ($rs->EOF) {
    print "<tr valign=top halign=left><td>";
    print "<br><font class=errmsg>Error: Localities not found.</font><br></td></tr>";
  } else {
    $select_list = "<select size=\"1\" onChange=\"populate(this.form.LOC_NBR_NAME, 'admin_locality.php?loc_nbr=');\" name=\"LOC_NBR_NAME\"><option></option>";
    while (!$rs->EOF) {
      $select_list .= "<option value=\"" . $rs->fields["LOC_NBR"] . "\">" . $rs->fields["LOC_NAME"] . ", " . $rs->fields["LOC_NBR"] . "</option>";
      $rs->MoveNext();
    }
    $select_list .= "</select>";
    print "<tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\">Select Locality to Update/Delete: " . $select_list . "</td>";
    print "</tr><tr valign=top halign=left><td align=\"center\">- OR -</td></tr><tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\"><input type=\"submit\" name=\"gotoinsert\" value=\"Insert New Record\" ></td>";
	print "</tr>";
  }
} else {
  if ( isset($_POST['gotoinsert']) ) {
    print " ";
  } else {
  $sql =  "SELECT LOC_NBR, LOC_NAME, LOC_DESCRIPTION, LAND_OWNER, COUNTY, STATE, GPS, MAP_REFERENCE, ERA, EPOCH, PERIOD, ";
  $sql .= "LOCAL_AGE, FORMATION_NAME, MEMBER_NAME, AGE_BEGIN, AGE_END, AGE_ESTIMATE, TAXA, NOTES, COLLECTION_YN, RECORDED_BY, RECORDED_DATE ";
  $sql .= "FROM LOCALITIES WHERE LOC_NBR = '" . $loc_nbr . "';"; 

  $rs = $db->Execute($sql);
  }
  if ($rs->EOF) {
    print "<font class=errmsg>Error: Locality [" . $loc_nbr . "] not found.</font><br>";
  } else {
    /****************************************************/
    //  Determine if posting has already occurred.  Otherwise use data selected from record.
    if (isset($_POST["loc_nbr"])) { $x_loc_nbr = $_POST["loc_nbr"]; } else { $x_loc_nbr = rtrim($rs->fields["LOC_NBR"]); }
    if (isset($_POST["loc_name"])) { $x_loc_name = $_POST["loc_name"]; } else { $x_loc_name = rtrim($rs->fields["LOC_NAME"]); }
    if (isset($_POST["loc_description"])) { $x_loc_description = $_POST["loc_description"]; } else { $x_loc_description = rtrim($rs->fields["LOC_DESCRIPTION"]); }
    if (isset($_POST["land_owner"])) { $x_land_owner = $_POST["land_owner"]; } else { $x_land_owner = rtrim($rs->fields["LAND_OWNER"]); }
    if (isset($_POST["county"])) { $x_county = $_POST["county"]; } else { $x_county = rtrim($rs->fields["COUNTY"]); }
    if (isset($_POST["state"])) { $x_state = $_POST["state"]; } else { $x_state = rtrim($rs->fields["STATE"]); }
    if (isset($_POST["gps"])) { $x_gps = $_POST["gps"]; } else { $x_gps = rtrim($rs->fields["GPS"]); }
    if (isset($_POST["map_reference"])) { $x_map_reference = $_POST["map_reference"]; } else { $x_map_reference = rtrim($rs->fields["MAP_REFERENCE"]); }
    if (isset($_POST["era"])) { $x_era = $_POST["era"]; } else { $x_era = rtrim($rs->fields["ERA"]); }
    if (isset($_POST["epoch"])) { $x_epoch = $_POST["epoch"]; } else { $x_epoch = rtrim($rs->fields["EPOCH"]); }
    if (isset($_POST["period"])) { $x_period = $_POST["period"]; } else { $x_period = rtrim($rs->fields["PERIOD"]); }
    if (isset($_POST["local_age"])) { $x_local_age = $_POST["local_age"]; } else { $x_local_age = rtrim($rs->fields["LOCAL_AGE"]); }
    if (isset($_POST["formation_name"])) { $x_formation_name = $_POST["formation_name"]; } else { $x_formation_name = rtrim($rs->fields["FORMATION_NAME"]); }
    if (isset($_POST["member_name"])) { $x_member_name = $_POST["member_name"]; } else { $x_member_name = rtrim($rs->fields["MEMBER_NAME"]); }
    if (isset($_POST["age_begin"])) { $x_age_begin = $_POST["age_begin"]; } else { $x_age_begin = rtrim($rs->fields["AGE_BEGIN"]); }
    if (isset($_POST["age_end"])) { $x_age_end = $_POST["age_end"]; } else { $x_age_end = rtrim($rs->fields["AGE_END"]); }
    if (isset($_POST["age_estimate"])) { $x_age_estimate = $_POST["age_estimate"]; } else { $x_age_estimate = rtrim($rs->fields["AGE_ESTIMATE"]); }
    if (isset($_POST["taxa"])) { $x_taxa = $_POST["taxa"]; } else { $x_taxa = rtrim($rs->fields["TAXA"]); }
    if (isset($_POST["notes"])) { $x_notes = $_POST["notes"]; } else { $x_notes = rtrim($rs->fields["NOTES"]); }
    if (isset($_POST["collection_yn"])) { $x_collection_yn = $_POST["collection_yn"]; } else { $x_collection_yn = rtrim($rs->fields["COLLECTION_YN"]); }
// Ver 2    $x_recorded_by = $rs->fields["RECORDED_BY"];
// Ver 2    $t = $rs->fields["RECORDED_DATE"];
// Ver 2    $x_recorded_date = substr($t,0,4)."-".substr($t,4,2)."-".substr($t,6,2).", ".substr($t,8,2).":".substr($t,10,2).":".substr($t,12,2);

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req1\">Locality # [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"loc_nbr\" value=\"".fix($x_loc_nbr)."\" size=50>";
    print "<vlvalidator name=\"req1\" type=\"required\" control=\"loc_nbr\" errmsg=\"Location Nbr required\"></td></tr>";
	
    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req2\">Locality Name: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"loc_name\" value=\"".fix($x_loc_name)."\" size=50>";
    print "<vlvalidator name=\"req2\" type=\"required\" control=\"loc_name\" errmsg=\"Location Name required\"></td></tr>";
	
    print $tr.$td1."Locality Description: </td>";
    print $td2."<TEXTAREA name=\"loc_description\" rows=\"4\" cols=\"50\" >". fix($x_loc_description). "</TEXTAREA></td></tr>";

    print $tr.$td1."Land Owner: </td>";
    print $td2."<input type=\"text\" name=\"land_owner\" value=\"". fix($x_land_owner) . "\" size=50></td></tr>";

    print $tr.$td1."County: </td>";
    print $td2."<input type=\"text\" name=\"county\" value=\"".fix($x_county)."\" size=30></td></tr>";

    print $tr.$td1."State: </td>";
    print $td2."<input type=\"text\" name=\"state\" value=\"". fix($x_state)."\" size=2></td></tr>";

    print $tr.$td1."GPS: </td>";
    print $td2."<input type=\"text\" name=\"gps\" value=\"". fix($x_gps)."\" size=40></td></tr>";
	
    print $tr.$td1."Map Reference: </td>";
    print $td2."<input type=\"text\" name=\"map_reference\" value=\"". fix($x_map_reference)."\" size=50></td></tr>";

    print $tr.$td1."Era: </td>";
    print $td2."<input type=\"text\" name=\"era\" value=\"". fix($x_era) ."\" size=30></td></tr>";

    print $tr.$td1."Epoch: </td>";
    print $td2."<input type=\"text\" name=\"epoch\" value=\"". fix($x_epoch)."\" size=30></td></tr>";

    print $tr.$td1."Period:  </td>";
    print $td2."<input type=\"text\" name=\"period\" value=\"". fix($x_period)."\" size=30></td></tr>";

    print $tr.$td1."Age: </td>";
    print $td2."<input type=\"text\" name=\"local_age\" value=\"". fix($x_local_age)."\" size=20></td></tr>";

    print $tr.$td1."Formation: </td>";
    print $td2."<input type=\"text\" name=\"formation_name\" value=\"". fix($x_formation_name)."\" size=50></td></tr>";

    print $tr.$td1."Member: </td>";
    print $td2."<input type=\"text\" name=\"member_name\" value=\"".fix($x_member_name)."\" size=50></td></tr>";

    print $tr.$td1."Age Begin: </td>";
    print $td2."<input type=\"text\" name=\"age_begin\" value=\"". fix($x_age_begin)."\" size=20></td></tr>";

    print $tr.$td1."Age End: </td>";
    print $td2."<input type=\"text\" name=\"age_end\" value=\"". fix($x_age_end)."\" size=20></td></tr>";
	
    print $tr.$td1."Age Estimate: </td>";
    print $td2."<input type=\"text\" name=\"age_estimate\" value=\"". fix($x_age_estimate)."\" size=20></td></tr>";

    print $tr.$td1."Taxa: </td>";
    print $td2."<TEXTAREA name=\"taxa\" rows=\"12\" cols=\"50\" >" . fix($x_taxa). "</TEXTAREA></td></tr>";
		
    print $tr.$td1."Notes: </td>";
    print $td2."<TEXTAREA name=\"notes\" rows=\"12\" cols=\"50\" >" . fix($x_notes). "</TEXTAREA></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"YN\">In Collections: </vllabel></td>";
    print $td2."<select size=\"1\" name=\"collection_yn\" ><option SELECTED>" . $x_collection_yn . "</option><option>Y</option><option>N</option></select>";
    print "<vlvalidator name=\"YN\" type=\"required\" control=\"collection_yn\" errmsg=\"In Collections is required and must be Y or N.\"></td></tr>";

// Ver 2    print $tr.$td1."Recorded By: </td>";
// Ver 2    print $td2. $x_recorded_by."</td></tr>";

// Ver 2    print $tr.$td1."Recorded Date: </td>";
// Ver 2    print $td2. $x_recorded_date."</td></tr>";

    print $tr."<td COLSPAN=2><br>".
	      "[<font class=defaultErr>key</font>] - Primary key field(s) for this table.</td></tr>";
	
    ## save original key value in case it is updated.
    print "<input type=\"hidden\" name=\"hiddenkey\" value=\"". $x_loc_nbr . "\" size=50>";
  }
}

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or $loc_nbr != '' ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

print "</table></form>";

/****************************************************************************/
include ("./include/footer.php");
?>
</body>
</html>