<?php
/***********************************************************************************
*  admin_morphotype_categories.php                        Wagner Database Solutions, Inc.
*    v1.02 - 28 Aug 2004  (c) 2004 Steve Wagner.  All rights reserved.
*            See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Screen to maintain the MORPHOTYPE_CATEGORIES table.
* 
*  Notes: 
*    1. The PHP funtion fix()) is in include/header_admin.php.
*    2. The Javascript function populate())is in include/header_admin.php.
*
*  Change Log:
*    v1.0   Initial beta release
*    v1.01  Changed "key" note. (3/4/04)
*    v1.02  Added rtrim() around fields (8/28/04)
*
************************************************************************************/
include_once ("./vdaemon/vdaemon.php");
$header='ADMIN';
include_once ("./include/config.php");
include_once ("./include/header.php");
include_once ("./include/header_admin.php");

?>
<html><body><head>
</head>
<center><b><font class=pch>Morphotype Category Administration</font></b><br><br></center>

<!-- This form is a fake form to call if user wants to get out of insert/update and get new record. --> 
<form method="POST" name="NoVal" action="admin_morphotype_categories.php"></form>

<?php

//print "morphotype_nbr: [" .$morphotype_nbr. "], category: [" .$category_id . "]  Action: " . $_POST["insert"] . $_POST["gotoinsert"] . $_POST["update"] . $_POST["clear"] . $_POST["delete"] . "---";

if ( isset($_POST['insert']) or isset($_POST['update']) ) {            // ******************INSERT/UPDATE

  if ( isset($_POST['insert']) ) {
    $nbr = -1;
    $nbr2 = -1;
  } elseif ( isset($_POST['update']) ) {
    $nbr = $_POST["hiddenkey"]; # use saved key field in case user updated it.
    $nbr2 = $_POST["hiddenkey2"]; # use saved key field in case user updated it.
  }
  $sql = "SELECT * FROM MORPHOTYPE_CATEGORIES WHERE MORPHOTYPE_NBR = '" .$nbr. "' AND CATEGORY_ID = '" .$nbr2. "';";  // get record either null or with where clause.
  
  # Select record from database
  $rsx = $db->Execute($sql); # Execute the query for empty record (Insert) or with where (update).
  $record = array(); # Initialize an array

  # Set values for fields in record. Note: field names are case-insensitive.
  $record["Morphotype_Nbr"] = stripslashes($_POST["morphotype_nbr"]);
  $record["Category_Id"] = stripslashes($_POST["category_id"]);
  
  if ( isset($_POST['insert']) ) {
    # Pass empty recordset & array with data to insert to GetInsertSQL. Fully formatted insert sql will be returned.
    $insertSQL = $db->GetInsertSQL($rsx, $record);
    if ($db->Execute($insertSQL) === false) { # Insert the record into the database
      print "<BR>sql: " . $insertSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error inserting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully inserted...</font><br>\n";
    }
  } elseif ( isset($_POST['update']) ) {
    # Pass recordset & array with data to update to GetUpdateSQL. Fully formatted update sql will be 
	# returned...with WHERE. If data not changed, no recordset returned
    $updateSQL = $db->GetUpdateSQL($rsx, $record);
	if ( $updateSQL == '') { print $ts.'<font class=errmsg>You did not change any data!</font>'; }
    if ($db->Execute($updateSQL) === false) {
      print "<BR>sql: " . $updateSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error updating record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully updated...</font><br>\n";
    }
  }
} elseif ( isset($_POST['clear'])) {       // ************************************************CLEAR
  $morphotype_nbr = '';
  $category_id = '';
} elseif ( isset($_POST['delete'])) {       // ************************************************DELETE
  $deleteSQL = "DELETE FROM MORPHOTYPE_CATEGORIES WHERE MORPHOTYPE_NBR='".$_POST["morphotype_nbr"]."' AND CATEGORY_ID = '".$_POST["category_id"]."';";
  if ($db->Execute($deleteSQL) === false) {
    print "<BR>sql: " . $deleteSQL . "<br><br>\n";
    print $ts.'<font class=errmsg>Error deleting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
   } else {
    print $ts."<font class=msg>Record successfully deleted...</font><br>\n";
   }
   $morphotype_nbr = '';
   $category_id = '';
}

print "<form method=\"POST\" name=\"AMorphotype_Categories\" runat=\"vdaemon\" action=\"admin_morphotype_categories.php\">";
print "<vlsummary class=\"defaultErr\" headertext=\"Error(s) found:\">";

print "<table WIDTH=\"95%\" align=\"center\" border=\"0\" cellpadding=\"5\">";

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or ($morphotype_nbr != '' and $category_id != '' ) ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

if ( ( $morphotype_nbr == '' and $category_id == '') and !isset($_POST['insert']) and !isset($_POST['gotoinsert']) ) {
  $sql =  "SELECT MORPHOTYPE_NBR, CATEGORY_ID FROM MORPHOTYPE_CATEGORIES ORDER BY MORPHOTYPE_NBR, CATEGORY_ID;";
  /************  Select list for MORPHOTYPE_CATEGORIES ***********/
  $rs = $db->Execute($sql);
  if ($rs->EOF) {
    print "<tr valign=top halign=left><td>";
    print "<br><font class=errmsg>Error: MORPHOTYPE_CATEGORIES not found.</font><br></td></tr>";
  } else {
    $select_list = "<select size=\"1\" onChange=\"populate(this.form.MORPHOTYPE_CATEGORIES, 'admin_morphotype_categories.php?morphotype_nbr=', 'category_id=');\" name=\"MORPHOTYPE_CATEGORIES\"><option></option>";
    while (!$rs->EOF) {
      $select_list .= "<option value=\"" . $rs->fields["MORPHOTYPE_NBR"] . "-----" . $rs->fields["CATEGORY_ID"] . "\">" .
	                  $rs->fields["MORPHOTYPE_NBR"] . ", " . $rs->fields["CATEGORY_ID"] . "</option>";
      $rs->MoveNext();
    }
    $select_list .= "</select>";
    print "<tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\">Select Morphotype Category to Update/Delete: " . $select_list . "</td>";
    print "</tr><tr valign=top halign=left><td align=\"center\">- OR -</td></tr><tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\"><input type=\"submit\" name=\"gotoinsert\" value=\"Insert New Record\" ></td>";
	print "</tr>";
  }
} else {
  if ( isset($_POST['gotoinsert']) ) {
    print " ";
  } else {
    $sql =  "SELECT MORPHOTYPE_NBR, CATEGORY_ID FROM MORPHOTYPE_CATEGORIES WHERE MORPHOTYPE_NBR = '" .
           $morphotype_nbr . "' AND CATEGORY_ID = '" . $category_id . "';"; 
    $rs = $db->Execute($sql);
  }
  if ($rs->EOF) {

    print "<font class=errmsg>Error: MORPHOTYPE_CATEGORIES [" . $morphotype_nbr . "]/[" . $category_id . "] not found.</font><br>";
  } else {
    /****************************************************/
    //  Determine if posting has already occurred.  Otherwise use data selected from record.
    if (isset($_POST["morphotype_nbr"])) { $x_morphotype_nbr= $_POST["morphotype_nbr"]; } else { $x_morphotype_nbr = rtrim($rs->fields["MORPHOTYPE_NBR"]); }
    if (isset($_POST["category_id"])) { $x_category_id = $_POST["category_id"]; } else { $x_category_id = rtrim($rs->fields["CATEGORY_ID"]); }
	
    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req1\">Morphotype Nbr: [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"morphotype_nbr\" value=\"".fix($x_morphotype_nbr)."\" size=50>";
    print "<vlvalidator name=\"req1\" type=\"required\" control=\"morphotype_nbr\" errmsg=\"Morphotype Nbr required\"></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req2\">Category ID: [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"category_id\" value=\"".fix($x_category_id)."\" size=90>";
    print "<vlvalidator name=\"req2\" type=\"required\" control=\"category_id\" errmsg=\"Category ID required\"></td></tr>";

    print $tr."<td COLSPAN=2><br>".
	      "[<font class=defaultErr>key</font>] - Primary key field(s) for this table.</td></tr>";

    ## save original key values in case it is updated.
    print "<input type=\"hidden\" name=\"hiddenkey\" value=\"". $x_morphotype_nbr . "\" size=50>";
    print "<input type=\"hidden\" name=\"hiddenkey2\" value=\"". $x_category_id . "\" size=100>";

  }
}
if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or ($morphotype_nbr != '' and $category_id != '' ) ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

print "</table></form>";

/****************************************************************************/
include ("./include/footer.php");
?>
</body>
</html>