<?php
/***********************************************************************************
*  admin_morphotypes.php                        Wagner Database Solutions, Inc.
*    v1.05 - 1 Sep 2004  (c) 2004 Steve Wagner.  All rights reserved.
*            See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Screen to maintain the MORPHOTYPES table.
* 
*  Notes: 
*    1. The PHP funtion fix()) is in include/header_admin.php.
*    2. The Javascript function populate())is in include/header_admin.php.
*
*  Change Log:
*    v1.0   Initial beta release (2/22/2004)
*    v1.01  Added select list for approved_for_display and publication_id. (2/23/2004)
*    v1.02  Removed last_update_date for this version.
*    v1.03  Changed "key" note. (3/4/04)
*    v1.04  Added rtrim() around fields (8/28/04)
*    v1.05  Added blank selection for Publication ID (9/1/04)
*
************************************************************************************/
include_once ("./vdaemon/vdaemon.php");
$header='ADMIN';
include_once ("./include/config.php");
include_once ("./include/header.php");
include_once ("./include/header_admin.php");

?>
<html><body><head>
</head>
<center><b><font class=pch>Morphotype Administration</font></b></center><br>

<!-- This form is a fake form to call if user wants to get out of insert/update and get new record. --> 
<form method="POST" name="NoVal" action="admin_morphotypes.php"></form>

<?php

//print "Morph_nbr: [" .$morphotype_nbr. "]  Action: " . $_POST["insert"] . $_POST["gotoinsert"] . $_POST["update"] . $_POST["clear"] . $_POST["delete"] . "---";

if ( isset($_POST['insert']) or isset($_POST['update']) ) {            // ******************INSERT/UPDATE

  if ( isset($_POST['insert']) ) {
    $nbr = -1;  
  } elseif ( isset($_POST['update']) ) {
    $nbr = $_POST["hiddenkey"]; # used saved key field in case user updated it.
  }
  $sql = "SELECT * FROM MORPHOTYPES WHERE morphotype_nbr = '" .$nbr. "';";  // get record either null or with where clause.
  
  # Select record from database
  $rsx = $db->Execute($sql); # Execute the query for empty record (Insert) or with where (update).
  $record = array(); # Initialize an array

  # Set values for fields in record. Note: field names are case-insensitive.
  $record["Morphotype_Nbr"] = stripslashes($_POST["morphotype_nbr"]);
  $record["Genus_Name"] = stripslashes($_POST["genus_name"]);
  $record["Species_Name"] = stripslashes($_POST["species_name"]);
  $record["Author"] = stripslashes($_POST["author"]);
  $record["Family"] = stripslashes($_POST["family"]);
  $record["The_Order"] = stripslashes($_POST["the_order"]);
  $record["Old_Names"] = stripslashes($_POST["old_names"]);
  $record["Higher_Taxon"] = stripslashes($_POST["higher_taxon"]);
  $record["Diagnostic_Features"] = stripslashes($_POST["diagnostic_features"]);
  $record["Morphotype_Text"] = stripslashes($_POST["morphotype_text"]);
  $record["Publication_Id"] = stripslashes($_POST["publication_id"]);
  $record["Publication_Help"] = stripslashes($_POST["publication_help"]);
  $record["Rarity_Scale"] = stripslashes($_POST["rarity_scale"]);
  $record["Approved_For_Display"] = stripslashes($_POST["approved_for_display"]);
  $record["Approved_By"] = stripslashes($_POST["approved_by"]);
  $record["Approved_Date"] = stripslashes($_POST["approved_date"]);
// Ver 2  $record["Last_Update_Date"] = stripslashes($_POST["last_update_date"]);

  if ( isset($_POST['insert']) ) {
    # Pass empty recordset & array with data to insert to GetInsertSQL. Fully formatted insert sql will be returned.
    $insertSQL = $db->GetInsertSQL($rsx, $record);
    if ($db->Execute($insertSQL) === false) { # Insert the record into the database
      print "<BR>sql: " . $insertSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error inserting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully inserted...</font><br>\n";
    }
  } elseif ( isset($_POST['update']) ) {
    # Pass recordset & array with data to update to GetUpdateSQL. Fully formatted update sql will be 
	# returned...with WHERE. If data not changed, no recordset returned
    $updateSQL = $db->GetUpdateSQL($rsx, $record);
	if ( $updateSQL == '') { print $ts.'<font class=errmsg>You did not change any data!</font>'; }
    if ($db->Execute($updateSQL) === false) {
      print "<BR>sql: " . $updateSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error updating record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully updated...</font><br>\n";
    }
  }
} elseif ( isset($_POST['clear'])) {       // ************************************************CLEAR
  $morphotype_nbr = '';
} elseif ( isset($_POST['delete'])) {       // ************************************************DELETE
  $deleteSQL = "DELETE FROM MORPHOTYPES WHERE MORPHOTYPE_NBR='" .  $_POST["morphotype_nbr"] . "';";
  if ($db->Execute($deleteSQL) === false) {
    print "<BR>sql: " . $deleteSQL . "<br><br>\n";
    print $ts.'<font class=errmsg>Error deleting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
   } else {
    print $ts."<font class=msg>Record successfully deleted...</font><br>\n";
   }
   $morphotype_nbr = '';
}

print "<form method=\"POST\" name=\"Amorphotype_nbr\" runat=\"vdaemon\" action=\"admin_morphotypes.php\">";
print "<vlsummary class=\"defaultErr\" headertext=\"Error(s) found:\">";

print "<table WIDTH=\"95%\" align=\"center\" border=\"0\" cellpadding=\"5\">";

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or $morphotype_nbr != '' ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

if ($morphotype_nbr == '' and !isset($_POST['insert']) and !isset($_POST['gotoinsert']) ) {
  $sql =  "SELECT MORPHOTYPE_NBR, GENUS_NAME FROM MORPHOTYPES ORDER BY MORPHOTYPE_NBR;";
  /************  Select list for morphotype_nbr ***********/
  $rs = $db->Execute($sql);
  if ($rs->EOF) {
    print "<tr valign=top halign=left><td>";
    print "<br><font class=errmsg>Error: Morphotype Nbr not found.</font><br></td></tr>";
  } else {
    $select_list = "<select size=\"1\" onChange=\"populate(this.form.MORPHOTYPE_NBR, 'admin_morphotypes.php?morphotype_nbr=');\" name=\"MORPHOTYPE_NBR\"><option></option>";
    while (!$rs->EOF) {
      $select_list .= "<option value=\"" . $rs->fields["MORPHOTYPE_NBR"] . "\">" . $rs->fields["MORPHOTYPE_NBR"] . ", " . $rs->fields["GENUS_NAME"] . "</option>";
      $rs->MoveNext();
    }
    $select_list .= "</select>";
    print "<tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\">Select Morphotype to Update/Delete: " . $select_list . "</td>";
    print "</tr><tr valign=top halign=left><td align=\"center\">- OR -</td></tr><tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\"><input type=\"submit\" name=\"gotoinsert\" value=\"Insert New Record\" ></td>";
	print "</tr>";
  }
} else {
  if ( isset($_POST['gotoinsert']) ) {
    print " ";
  } else {
  $sql =  "SELECT MORPHOTYPE_NBR, GENUS_NAME, SPECIES_NAME, AUTHOR, FAMILY, THE_ORDER, OLD_NAMES, HIGHER_TAXON, ";
  $sql .= "DIAGNOSTIC_FEATURES, MORPHOTYPE_TEXT, PUBLICATION_ID, PUBLICATION_HELP, RARITY_SCALE, APPROVED_FOR_DISPLAY, ";
  $sql .= "APPROVED_BY, APPROVED_DATE, LAST_UPDATE_DATE "; 
  $sql .= "FROM MORPHOTYPES WHERE MORPHOTYPE_NBR = '" . $morphotype_nbr . "';";
  
  $rs = $db->Execute($sql);
  }
  if ($rs->EOF) {
    print "<font class=errmsg>Error: Morphotype [" . $morphotype_nbr . "] not found.</font><br>";
  } else {
    /****************************************************/
    //  Determine if posting has already occurred.  Otherwise use data selected from record.
    if (isset($_POST["morphotype_nbr"])) { $x_morphotype_nbr = $_POST["morphotype_nbr"]; } else { $x_morphotype_nbr = rtrim($rs->fields["MORPHOTYPE_NBR"]); }
    if (isset($_POST["genus_name"])) { $x_genus_name = $_POST["genus_name"]; } else { $x_genus_name = rtrim($rs->fields["GENUS_NAME"]); }
    if (isset($_POST["species_name"])) { $x_species_name = $_POST["species_name"]; } else { $x_species_name = rtrim($rs->fields["SPECIES_NAME"]); }
    if (isset($_POST["author"])) { $x_author = $_POST["author"]; } else { $x_author = rtrim($rs->fields["AUTHOR"]); }
    if (isset($_POST["family"])) { $x_family = $_POST["family"]; } else { $x_family = rtrim($rs->fields["FAMILY"]); }
    if (isset($_POST["the_order"])) { $x_the_order = $_POST["the_order"]; } else { $x_the_order = rtrim($rs->fields["THE_ORDER"]); }
    if (isset($_POST["old_names"])) { $x_old_names = $_POST["old_names"]; } else { $x_old_names = rtrim($rs->fields["OLD_NAMES"]); }
    if (isset($_POST["higher_taxon"])) { $x_higher_taxon = $_POST["higher_taxon"]; } else { $x_higher_taxon = rtrim($rs->fields["HIGHER_TAXON"]); }
    if (isset($_POST["diagnostic_features"])) { $x_diagnostic_features = $_POST["diagnostic_features"]; } else { $x_diagnostic_features = rtrim($rs->fields["DIAGNOSTIC_FEATURES"]); }
    if (isset($_POST["morphotype_text"])) { $x_morphotype_text = $_POST["morphotype_text"]; } else { $x_morphotype_text = rtrim($rs->fields["MORPHOTYPE_TEXT"]); }	
    if (isset($_POST["publication_id"])) { $x_publication_id = $_POST["publication_id"]; } else { $x_publication_id = rtrim($rs->fields["PUBLICATION_ID"]); }
    if (isset($_POST["publication_help"])) { $x_publication_help = $_POST["publication_help"]; } else { $x_publication_help = rtrim($rs->fields["PUBLICATION_HELP"]); }
    if (isset($_POST["rarity_scale"])) { $x_rarity_scale = $_POST["rarity_scale"]; } else { $x_rarity_scale = rtrim($rs->fields["RARITY_SCALE"]); }
    if (isset($_POST["approved_for_display"])) { $x_approved_for_display = $_POST["approved_for_display"]; } else { $x_approved_for_display = rtrim($rs->fields["APPROVED_FOR_DISPLAY"]); }
    if (isset($_POST["approved_by"])) { $x_approved_by = $_POST["approved_by"]; } else { $x_approved_by = rtrim($rs->fields["APPROVED_BY"]); }
    if (isset($_POST["approved_date"])) { $x_approved_date = $_POST["approved_date"]; } else { $x_approved_date = rtrim($rs->fields["APPROVED_DATE"]); }
// Ver 2     if (isset($_POST["last_update_date"])) { $x_last_update_date = $_POST["last_update_date"]; } else { $x_last_update_date = $rs->fields["LAST_UPDATE_DATE"]; }
// Ver 2     $t = $rs->fields["LAST_UPDATE_DATE"];
// Ver 2     $x_last_update_date = substr($t,0,4)."-".substr($t,4,2)."-".substr($t,6,2).", ".substr($t,8,2).":".substr($t,10,2).":".substr($t,12,2);

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req1\">Morphotype Nbr [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"morphotype_nbr\" value=\"".fix($x_morphotype_nbr)."\" size=50>";
    print "<vlvalidator name=\"req1\" type=\"required\" control=\"morphotype_nbr\" errmsg=\"Morphotype Nbr required\"></td></tr>";

    print $tr.$td1."Genus Name: </td>";
    print $td2."<input type=\"text\" name=\"genus_name\" value=\"".fix($x_genus_name)."\" size=50></td></tr>";

    print $tr.$td1."Species Name: </td>";
    print $td2."<input type=\"text\" name=\"species_name\" value=\"".fix($x_species_name)."\" size=70></td></tr>";
	
    print $tr.$td1."Author: </td>";
    print $td2."<input type=\"text\" name=\"author\" value=\"". fix($x_author) . "\" size=70></td></tr>";

    print $tr.$td1."Family: </td>";
    print $td2."<input type=\"text\" name=\"family\" value=\"".fix($x_family)."\" size=50></td></tr>";

    print $tr.$td1."Order: </td>";
    print $td2."<input type=\"text\" name=\"the_order\" value=\"". fix($x_the_order)."\" size=50></td></tr>";

    print $tr.$td1."Old Names: </td>";
    print $td2."<input type=\"text\" name=\"old_names\" value=\"". fix($x_old_names)."\" size=70></td></tr>";
	
    print $tr.$td1."Higher Taxon: </td>";
    print $td2."<input type=\"text\" name=\"higher_taxon\" value=\"". fix($x_higher_taxon)."\" size=50></td></tr>";

    print $tr.$td1."Diagnostic features: </td>";
    print $td2."<TEXTAREA name=\"diagnostic_features\" rows=\"4\" cols=\"70\" >". fix($x_diagnostic_features). "</TEXTAREA></td></tr>";

    print $tr.$td1."Morphotype text:  </td>";
    print $td2."<TEXTAREA name=\"morphotype_text\" rows=\"4\" cols=\"70\" >". fix($x_morphotype_text). "</TEXTAREA></td></tr>";

    print $tr.$td1."Publication ID:</td>";
    print $td2;
    $select_list = "<select size=\"1\" name=\"publication_id\" ><option SELECTED>" . $x_publication_id . "</option>" .
    $sql =  "SELECT PUBLICATION_ID FROM PUBLICATIONS ORDER BY PUBLICATION_ID;";
    /************  Select list for publications ***********/
    $rsp = $db->Execute($sql);
    if ($rsp->EOF) {
      print "<font class=errmsg>Error: Publication Id not found.</font>";
    } else {
      while (!$rsp->EOF) {
        $select_list .= "<option value=\"" . $rsp->fields["PUBLICATION_ID"] . "\">" . $rsp->fields["PUBLICATION_ID"] . "</option>";
        $rsp->MoveNext();
      }
      $select_list .= "<option value=\"\" ></option></select></td></tr>";
	  print $select_list;
    } 

    print $tr.$td1."Publication Help: </td>";
    print $td2."<input type=\"text\" name=\"publication_help\" value=\"". fix($x_publication_help)."\" size=50></td></tr>";

    print $tr.$td1."Rarity Scale: </td>";
    print $td2."<input type=\"text\" name=\"rarity_scale\" value=\"".fix($x_rarity_scale)."\" size=10></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"YN\">Approved For Display: </vllabel></td>";
    print $td2."<select size=\"1\" name=\"approved_for_display\" ><option SELECTED>" . $x_approved_for_display . "</option><option>Y</option><option>N</option></select>";
    print "<vlvalidator name=\"YN\" type=\"required\" control=\"approved_for_display\" errmsg=\"Approved for Display is required and must be Y or N.\"></td></tr>";

    print $tr.$td1."Approved By: </td>";
    print $td2. "<input type=\"text\" name=\"approved_by\" value=\"". fix($x_approved_by)."\" size=30></td></tr>";

    print $tr.$td1."Approved Date: </td>";
    print $td2. "<input type=\"text\" name=\"approved_date\" value=\"". fix($x_approved_date)."\" size=10>&nbsp;&nbsp;(YYYY-MM-DD)</td></tr>";
	
// Ver 2     print $tr.$td1."Last Update Date: </td>";
// Ver 2     print $td2. $x_last_update_date."</td></tr>";

    print $tr."<td COLSPAN=2><br>".
	      "[<font class=defaultErr>key</font>] - Primary key field(s) for this table.</td></tr>";
	
    ## save original key value in case it is updated.
    print "<input type=\"hidden\" name=\"hiddenkey\" value=\"". $x_morphotype_nbr . "\" size=30>";

  }
}

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or $morphotype_nbr != '' ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

print "</table></form>";

/****************************************************************************/
include ("./include/footer.php");
?>
</body>
</html>