<?php
/***********************************************************************************
*  admin_specimens.php                        Wagner Database Solutions, Inc.
*    v1.06 - 28 Aug 2004  (c) 2004 Steve Wagner.  All rights reserved.
*            See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Screen to maintain the SPECIMENS table.
* 
*  Notes: 
*    1. The PHP funtion fix()) is in include/header_admin.php.
*    2. The Javascript function populate())is in include/header_admin.php.
*
*  Change Log:
*    v1.0   Initial beta release (2/22/2004))
*    v1.01  Added select list for specimen_cat, collection_id and approved_for_display. (2/23/2004)
*    v1.02  Removed last_update_date, created_by and creation_date for this version. 
*           None of the other tables have these fields.
*    v1.03  Added MORPHOTYPES tablename in ORDER BY for select_list for 
*              ORDER BY for ORDER BY MORPHOTYPES.MORPHOTYPE_NBR (2/27/2004)
*    v1.04  Changed "key" note. (3/4/04)
*    v1.05  Added urlencode() around specimen_nbr for Netscape. (3/7/04)
*    v1.06  Added rtrim() around fields (8/28/04)
*
************************************************************************************/
include_once ("./vdaemon/vdaemon.php");
$header='ADMIN';
include_once ("./include/config.php");
include_once ("./include/header.php");
include_once ("./include/header_admin.php");

?>
<html><body><head>
</head>
<center><b><font class=pch>Specimens Administration</font></b><br><br></center>

<!-- This form is a fake form to call if user wants to get out of insert/update and get new record. --> 
<form method="POST" name="NoVal" action="admin_specimens.php"></form>

<?php

//print "morphotype nbr: [" .$morphotype_nbr. "], specimen: [" .$specimen_nbr. "]  Action: " . $_POST["insert"] . $_POST["gotoinsert"] . $_POST["update"] . $_POST["clear"] . $_POST["delete"] . "---";

if ( isset($_POST['insert']) or isset($_POST['update']) ) {            // ******************INSERT/UPDATE

  if ( isset($_POST['insert']) ) {
    $nbr = -1;
    $nbr2 = -1;
  } elseif ( isset($_POST['update']) ) {
    $nbr = $_POST["hiddenkey"]; # use saved key field in case user updated it.
    $nbr2 = $_POST["hiddenkey2"]; # use saved key field in case user updated it.
  }
  $sql = "SELECT * FROM SPECIMENS WHERE MORPHOTYPE_NBR = '" .$nbr. "' AND SPECIMEN_NBR = '" .$nbr2. "';";  // get record either null or with where clause.
  
  # Select record from database
  $rsx = $db->Execute($sql); # Execute the query for empty record (Insert) or with where (update).
  $record = array(); # Initialize an array

  # Set values for fields in record. Note: field names are case-insensitive.
  $record["Morphotype_Nbr"] = stripslashes($_POST["morphotype_nbr"]);
  $record["Specimen_Nbr"] = stripslashes($_POST["specimen_nbr"]);
  $record["Specimen_Cat"] = stripslashes($_POST["specimen_cat"]);
  $record["Organ"] = stripslashes($_POST["organ"]);
  $record["Loc_Nbr"] = stripslashes($_POST["loc_nbr"]);
  $record["Collection_Id"] = stripslashes($_POST["collection_id"]);
  $record["Collected_By"] = stripslashes($_POST["collected_by"]);
  $record["Collected_Date"] = stripslashes($_POST["collected_date"]);
  $record["Specimen_Text"] = stripslashes($_POST["specimen_text"]);
  $record["Acq_Status"] = stripslashes($_POST["acq_status"]);
  $record["Acq_Date"] = stripslashes($_POST["acq_date"]);
  $record["Acq_From"] = stripslashes($_POST["acq_from"]);
  $record["Acq_Exchange"] = stripslashes($_POST["acq_exchange"]);
  $record["Approved_For_Display"] = stripslashes($_POST["approved_for_display"]);
  $record["Approved_By"] = stripslashes($_POST["approved_by"]);
  $record["Approved_Date"] = stripslashes($_POST["approved_date"]);
// Ver 2  $record["Last_Update_Date"] = stripslashes($_POST["last_update_date"]);
  
  if ( isset($_POST['insert']) ) {
    # Pass empty recordset & array with data to insert to GetInsertSQL. Fully formatted insert sql will be returned.
    $insertSQL = $db->GetInsertSQL($rsx, $record);
    if ($db->Execute($insertSQL) === false) { # Insert the record into the database
      print "<BR>sql: " . $insertSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error inserting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully inserted...</font><br>\n";
    }
  } elseif ( isset($_POST['update']) ) {
    # Pass recordset & array with data to update to GetUpdateSQL. Fully formatted update sql will be 
	# returned...with WHERE. If data not changed, no recordset returned
    $updateSQL = $db->GetUpdateSQL($rsx, $record);
	if ( $updateSQL == '') { print $ts.'<font class=errmsg>You did not change any data!</font>'; }
    if ($db->Execute($updateSQL) === false) {
      print "<BR>sql: " . $updateSQL . "<br><br>\n";
      print $ts.'<font class=errmsg>Error updating record! ['.$db->ErrorMsg().'].</font><BR><BR>';
    } else {
      print $ts."<font class=msg>Record successfully updated...</font><br>\n";
    }
  }
} elseif ( isset($_POST['clear'])) {       // ************************************************CLEAR
  $morphotype_nbr = '';
  $specimen_nbr = '';
} elseif ( isset($_POST['delete'])) {       // ************************************************DELETE
  $deleteSQL = "DELETE FROM SPECIMENS WHERE MORPHOTYPE_NBR='" .  $_POST["morphotype_nbr"] . "' AND SPECIMEN_NBR = '" .$_POST["specimen_nbr"]. "';";
  if ($db->Execute($deleteSQL) === false) {
    print "<BR>sql: " . $deleteSQL . "<br><br>\n";
    print $ts.'<font class=errmsg>Error deleting record! ['.$db->ErrorMsg().'].</font><BR><BR>';
   } else {
    print $ts."<font class=msg>Record successfully deleted...</font><br>\n";
   }
   $morphotype_nbr = '';
   $specimen_nbr = '';
}

print "<form method=\"POST\" name=\"ASpecimens\" runat=\"vdaemon\" action=\"admin_specimens.php\">";
print "<vlsummary class=\"defaultErr\" headertext=\"Error(s) found:\">";

print "<table WIDTH=\"95%\" align=\"center\" border=\"0\" cellpadding=\"5\">";

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or ($morphotype_nbr != '' and $specimen_nbr != '' ) ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

if ( ( $morphotype_nbr == '' and $specimen_nbr == '' ) and !isset($_POST['insert']) and !isset($_POST['gotoinsert']) ) {
  $sql =  "SELECT MORPHOTYPES.MORPHOTYPE_NBR, SPECIMEN_NBR FROM MORPHOTYPES, SPECIMENS WHERE MORPHOTYPES.MORPHOTYPE_NBR = SPECIMENS.MORPHOTYPE_NBR ORDER BY MORPHOTYPES.MORPHOTYPE_NBR;";
  /************  Select list for SPECIMENS ***********/
  $rs = $db->Execute($sql);
  if ($rs->EOF) {
    print "<tr valign=top halign=left><td>";
    print "<br><font class=errmsg>Error: Specimen not found.</font><br></td></tr>";
  } else {
    $select_list = "<select size=\"1\" onChange=\"populate(this.form.MORPHOTYPE_SPECIMEN_NBR, 'admin_specimens.php?morphotype_nbr=', 'specimen_nbr=');\" name=\"MORPHOTYPE_SPECIMEN_NBR\"><option></option>";
    while (!$rs->EOF) {
      $select_list .= "<option value=\"" . $rs->fields["MORPHOTYPE_NBR"] . "-----" . urlencode($rs->fields["SPECIMEN_NBR"]) . "\">" .
	                  $rs->fields["MORPHOTYPE_NBR"] . ", " . $rs->fields["SPECIMEN_NBR"] . "</option>";
      $rs->MoveNext();
    }
    $select_list .= "</select>";
    print "<tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\">Select SPECIMEN to Update/Delete: " . $select_list . "</td>";
    print "</tr><tr valign=top halign=left><td align=\"center\">- OR -</td></tr><tr valign=top halign=left>";
    print "<td valign=\"top\" align=\"center\"><input type=\"submit\" name=\"gotoinsert\" value=\"Insert New Record\" ></td>";
	print "</tr>";
  }
} else {
  if ( isset($_POST['gotoinsert']) ) {
    print " ";
  } else {
    $sql  =  "SELECT MORPHOTYPE_NBR, SPECIMEN_NBR, SPECIMEN_CAT, ORGAN, LOC_NBR, COLLECTION_ID, COLLECTED_BY, COLLECTED_DATE, ";
    $sql .=  "SPECIMEN_TEXT, ACQ_STATUS, ACQ_DATE, ACQ_FROM, ACQ_EXCHANGE, APPROVED_FOR_DISPLAY, APPROVED_BY, APPROVED_DATE, LAST_UPDATE_DATE ";
    $sql .=  "FROM SPECIMENS WHERE MORPHOTYPE_NBR = '" . $morphotype_nbr . "' AND SPECIMEN_NBR = '" . $specimen_nbr . "';"; 
    $rs = $db->Execute($sql);
  }
  if ($rs->EOF) {

    print "<font class=errmsg>Error: Morphotype/Specimen [" . $morphotype_nbr . "]/[" . $specimen_nbr . "] not found.</font><br>";
  } else {
    /****************************************************/
    //  Determine if posting has already occurred.  Otherwise use data selected from record.
    if (isset($_POST["morphotype_nbr"])) { $x_morphotype_nbr = $_POST["morphotype_nbr"]; } else { $x_morphotype_nbr = rtrim($rs->fields["MORPHOTYPE_NBR"]); }
    if (isset($_POST["specimen_nbr"])) { $x_specimen_nbr = $_POST["specimen_nbr"]; } else { $x_specimen_nbr = rtrim($rs->fields["SPECIMEN_NBR"]); }
    if (isset($_POST["specimen_cat"])) { $x_specimen_cat = $_POST["specimen_cat"]; } else { $x_specimen_cat = rtrim($rs->fields["SPECIMEN_CAT"]); }
    if (isset($_POST["organ"])) { $x_organ = $_POST["organ"]; } else { $x_organ = rtrim($rs->fields["ORGAN"]); }
    if (isset($_POST["loc_nbr"])) { $x_loc_nbr = $_POST["loc_nbr"]; } else { $x_loc_nbr = rtrim($rs->fields["LOC_NBR"]); }
    if (isset($_POST["collection_id"])) { $x_collection_id = $_POST["collection_id"]; } else { $x_collection_id = rtrim($rs->fields["COLLECTION_ID"]); }
    if (isset($_POST["collected_by"])) { $x_collected_by = $_POST["collected_by"]; } else { $x_collected_by = rtrim($rs->fields["COLLECTED_BY"]); }
    if (isset($_POST["collected_date"])) { $x_collected_date = $_POST["collected_date"]; } else { $x_collected_date = rtrim($rs->fields["COLLECTED_DATE"]); }
    if (isset($_POST["specimen_text"])) { $x_specimen_text = $_POST["specimen_text"]; } else { $x_specimen_text = rtrim($rs->fields["SPECIMEN_TEXT"]); }
    if (isset($_POST["acq_status"])) { $x_acq_status = $_POST["acq_status"]; } else { $x_acq_status = rtrim($rs->fields["ACQ_STATUS"]); }
    if (isset($_POST["acq_date"])) { $x_acq_date = $_POST["acq_date"]; } else { $x_acq_date = rtrim($rs->fields["ACQ_DATE"]); }
    if (isset($_POST["acq_from"])) { $x_acq_from = $_POST["acq_from"]; } else { $x_acq_from = rtrim($rs->fields["ACQ_FROM"]); }
    if (isset($_POST["acq_exchange"])) { $x_acq_exchange = $_POST["acq_exchange"]; } else { $x_acq_exchange = rtrim($rs->fields["ACQ_EXCHANGE"]); }
    if (isset($_POST["approved_for_display"])) { $x_approved_for_display = $_POST["approved_for_display"]; } else { $x_approved_for_display = rtrim($rs->fields["APPROVED_FOR_DISPLAY"]); }
    if (isset($_POST["approved_by"])) { $x_approved_by = $_POST["approved_by"]; } else { $x_approved_by = rtrim($rs->fields["APPROVED_BY"]); }
    if (isset($_POST["approved_date"])) { $x_approved_date = $_POST["approved_date"]; } else { $x_approved_date = rtrim($rs->fields["APPROVED_DATE"]); }
// Ver 2    if (isset($_POST["last_update_date"])) { $x_last_update_date = $_POST["last_update_date"]; } else { $x_last_update_date = $rs->fields["LAST_UPDATE_DATE"]; }
// Ver 2    $t = $rs->fields["LAST_UPDATE_DATE"];
// Ver 2    $x_last_update_date = substr($t,0,4)."-".substr($t,4,2)."-".substr($t,6,2).", ".substr($t,8,2).":".substr($t,10,2).":".substr($t,12,2);

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req1\">Morphotype Nbr [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"morphotype_nbr\" value=\"".fix($x_morphotype_nbr)."\" size=50>";
    print "<vlvalidator name=\"req1\" type=\"required\" control=\"morphotype_nbr\" errmsg=\"Morphotype Nbr required\"></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"req2\">Specimen Nbr [<font class=defaultErr>key</font>]: </vllabel></td>";
    print $td2."<input type=\"text\" name=\"specimen_nbr\" value=\"".fix($x_specimen_nbr)."\" size=50>";
    print "<vlvalidator name=\"req2\" type=\"required\" control=\"specimen_nbr\" errmsg=\"Specimen Nbr required\"></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"cat\">Specimen Cat: </vllabel></td>";
    print $td2."<select size=\"1\" name=\"specimen_cat\" ><option SELECTED value=" .$x_specimen_cat ." >" . $x_specimen_cat .
	           "</option><option value=H>Holomorphotype</option><option value=T>Type Suite</option><option value=O>Other</option><option value=A>Attachment</option></select>";
    print "<vlvalidator name=\"cat\" type=\"required\" control=\"specimen_cat\" errmsg=\"Specimen Cat is required and must be H, T, O, A, etc.\"></td></tr>";

    print $tr.$td1."Organ: </td>";
    print $td2."<input type=\"text\" name=\"organ\" value=\"".fix($x_organ)."\" size=80></td></tr>";

    print $tr.$td1."Locality Nbr:</td>";
    print $td2;
    $select_list = "<select size=\"1\" name=\"loc_nbr\" ><option SELECTED value=\"" . $x_loc_nbr . "\">" . $x_loc_nbr . "</option>" .
    $sql =  "SELECT LOC_NBR, LOC_NAME FROM LOCALITIES ORDER BY LOC_NBR;";
    /************  Select list for localities ***********/
    $rsp = $db->Execute($sql);
    if ($rsp->EOF) {
      print "<font class=errmsg>Error: Loc Nbr not found.</font>";
    } else {
      while (!$rsp->EOF) {
        $select_list .= "<option value=\"" . $rsp->fields["LOC_NBR"] . "\">" . $rsp->fields["LOC_NAME"] . ", " . $rsp->fields["LOC_NBR"] . "</option>";
        $rsp->MoveNext();
      }
      $select_list .= "</select></td></tr>";
	  print $select_list;
    } 

    print $tr.$td1."Collection ID:</td>";
    print $td2;
    $select_list = "<select size=\"1\" name=\"collection_id\" ><option SELECTED value=\"" . $x_collection_id . "\">" . $x_collection_id . "</option>" .
    $sql =  "SELECT COLLECTION_ID FROM COLLECTIONS ORDER BY COLLECTION_ID;";
    /************  Select list for collections ***********/
    $rsp = $db->Execute($sql);
    if ($rsp->EOF) {
      print "<font class=errmsg>Error: Collection ID not found.</font>";
    } else {
      while (!$rsp->EOF) {
        $select_list .= "<option value=\"" . $rsp->fields["COLLECTION_ID"] . "\">" . $rsp->fields["COLLECTION_ID"] . "</option>";
        $rsp->MoveNext();
      }
      $select_list .= "</select></td></tr>";
	  print $select_list;
    } 

    print $tr.$td1."Collected By: </td>";
    print $td2."<input type=\"text\" name=\"collected_by\" value=\"". fix($x_collected_by). "\" size=80></td></tr>";

    print $tr.$td1."Collected Date: </td>";
    print $td2."<input type=\"text\" name=\"collected_date\" value=\"".fix($x_collected_date)."\" size=10></td></tr>";

    print $tr.$td1."Specimen Text: </td>";
    print $td2."<TEXTAREA name=\"specimen_text\" rows=\"12\" cols=\"50\" >" . fix($x_specimen_text). "</TEXTAREA></td></tr>";

    print $tr.$td1."Acquisition Status: </td>";
    print $td2."<input type=\"text\" name=\"acq_status\" value=\"".fix($x_acq_status)."\" size=10></td></tr>";

    print $tr.$td1."Acquisition Date: </td>";
    print $td2."<input type=\"text\" name=\"acq_date\" value=\"".fix($x_acq_date)."\" size=10>&nbsp;&nbsp;(YYYY-MM-DD)</td></tr>";

    print $tr.$td1."Acquired From: </td>";
    print $td2."<input type=\"text\" name=\"acq_from\" value=\"".fix($x_acq_from)."\" size=80></td></tr>";

    print $tr.$td1."Acquired Exchange: </td>";
    print $td2."<input type=\"text\" name=\"acq_exchange\" value=\"".fix($x_acq_exchange)."\" size=80></td></tr>";

    print $tr.$td1."<vllabel class=\"default\" errclass=\"defaultErr\" validators=\"YN\">Approved For Display: </vllabel></td>";
    print $td2."<select size=\"1\" name=\"approved_for_display\" ><option SELECTED>" . $x_approved_for_display . "</option><option>Y</option><option>N</option></select>";
    print "<vlvalidator name=\"YN\" type=\"required\" control=\"approved_for_display\" errmsg=\"Approved for Display is required and must be Y or N.\"></td></tr>";

    print $tr.$td1."Approved By: </td>";
    print $td2."<input type=\"text\" name=\"approved_by\" value=\"".fix($x_approved_by)."\" size=50></td></tr>";

    print $tr.$td1."Approved Date: </td>";
    print $td2."<input type=\"text\" name=\"approved_date\" value=\"".fix($x_approved_date)."\" size=10>&nbsp;&nbsp;(YYYY-MM-DD)</td></tr>";

// Ver 2    print $tr.$td1."Last Update Date: </td>";
// Ver 2    print $td2. $x_last_update_date."</td></tr>";
	
    print $tr."<td COLSPAN=2><br>".
	      "[<font class=defaultErr>key</font>] - Primary key field(s) for this table.</td></tr>";
		
    ## save original key values in case it is updated.
    print "<input type=\"hidden\" name=\"hiddenkey\" value=\"". $x_morphotype_nbr . "\" size=50>";
    print "<input type=\"hidden\" name=\"hiddenkey2\" value=\"". $x_specimen_nbr . "\" size=50>";
  }
}

if ( isset($_POST['insert']) or isset($_POST['gotoinsert']) or ($morphotype_nbr != '' and $specimen_nbr != '' ) ) {
  print "<tr valign=top halign=left><td COLSPAN=2>";
  if ( isset($_POST['gotoinsert']) ) {
    print "<input type=\"submit\" name=\"insert\" value=\"Insert Record\" >&nbsp;";
  } else {
    print "<input type=\"submit\" name=\"update\" value=\"Save Changes\" >&nbsp;";
  }
  print "<input type=\"submit\" name=\"delete\" value=\"Delete Record\" >&nbsp;&nbsp;&nbsp;";
  print "<input type=\"submit\" name=\"clear\" value=\"Select Another Record\" onSubmit=\"return false;\" onClick=\"return no_validate();\">&nbsp;";
  print "</td></tr>";
}

print "</table></form>";

/****************************************************************************/
include ("./include/footer.php");
?>
</body>
</html>