<?php
/***********************************************************************************
*  bibliography.php                        Wagner Database Solutions, Inc.
*    v1.02 - 27 Aug 2004  (c) 2004 Steve Wagner.  All rights reserved.
*             See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Displays the entire bibliography of publications if called from
*                the navigation tabs.  If called from the Details screen, only
*                displays the single publication.
* 
*  Change Log:
*    v1.0   Initial beta release. (3/4/2004)
*    v1.01  Moved date from end of line to after authors. (3/15/2004)
*    v1.02  Added rtrim() around fields. (8/27/04)
*
************************************************************************************/
include_once ("./include/config.php");
if (!$publication_id) {
  include_once ("./include/header.php");
} else {
  include_once ("./include/header_small.php");
}
?>
<html>
<body>

<?php

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver); 
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

$sql = "SELECT PUBLICATION_ID, AUTHORS, PUBLICATION_TYPE, TITLE, YEAR, ISSUE,
               PUBLICATION_NAME, PUBLISHER_NAME, PAGES, COMMENTS, DOCUMENT_LOCATION
          FROM PUBLICATIONS ";

if ( $publication_id ) {
  $sql .= "WHERE PUBLICATION_ID = \"" . $publication_id . "\";";
} else {
  print "<center><b><font class=pch>Publications</font></b></center><br>";
  $sql .= "ORDER BY PUBLICATION_ID;";
}

$rs = $db->Execute($sql);

if ($rs->EOF) {
  print "<form><br><b>No publications found for your selection.</b>&nbsp;&nbsp;&nbsp;";
  print "<input type=\"button\" value=\"GO BACK\" onClick=\"window.history.go(-1)\"></form>";
} else {

  while (!$rs->EOF) {

    print "<table WIDTH=\"95%\" align=\"center\" border=\"0\" cellpadding=\"5\">";
    print "<tr valign=top halign=left>";
  
    print "<td width=\"80%\" valign=\"top\" halign=\"left\">";
	
    print "<b>".$rs->fields["PUBLICATION_ID"]. "</b><br>";
    if (rtrim($rs->fields["AUTHORS"])) { print $rs->fields["AUTHORS"]; }
	// must check to see if field has data so screen won't show 2 commas and no data.
	if (rtrim($rs->fields["YEAR"])) { print ", ".$rs->fields["YEAR"]; }
	if (rtrim($rs->fields["TITLE"])) { print ", ".$rs->fields["TITLE"]; }
	if (rtrim($rs->fields["PUBLICATION_NAME"])) { print ", ".$rs->fields["PUBLICATION_NAME"]; }
	if (rtrim($rs->fields["ISSUE"])) { print ", ".$rs->fields["ISSUE"]; }
	if (rtrim($rs->fields["PAGES"])) { print ", pp. ".$rs->fields["PAGES"]; }
	if (rtrim($rs->fields["PUBLISHER_NAME"])) { print ", ".$rs->fields["PUBLISHER_NAME"]; }
//	if ($rs->fields["PUBLICATION_TYPE"]) { print ", ".$rs->fields["PUBLICATION_TYPE"]; }
	if (rtrim($rs->fields["COMMENTS"])) { print ", ".$rs->fields["COMMENTS"]; }
	if (rtrim($rs->fields["DOCUMENT_LOCATION"])) { print ", ".$rs->fields["DOCUMENT_LOCATION"]."<br>"; }
    print "</td></tr></table>";

    $rs->MoveNext();
  }
  print "</table>";

}

/****************************************************************************/
if (!$publication_id) {
  include ("./include/footer.php");
} else {
  print "<center><a href=javascript:close();>Close Window</a>";
}

?>

</body>
</html>
