<?php
/***********************************************************************************
*  create_tables.php                        Wagner Database Solutions, Inc.
*    v1.0 - 6 May 2004  (c) 2004 Steve Wagner.  All rights reserved.
*           See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Creates the required tables for the PaleoCollaborator application
*                and inserts base records to begin system use.  Uses AdoDB to make
*                table creates and inserts more generic.
* 
*  Change Log:
*    v1.0   Initial beta release. (5/6/2004)
*
************************************************************************************/
include_once ("include/config.php");
include_once ("include/header.php");
?>
<html>
<body>

<?php

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver);
// $db->debug = true;  #true
if ($db->Connect($server, $user, $password, $database) === false) {
   print 'Error Connecting: ['.$db->ErrorMsg().'].<BR><BR>';
} else {
   print ('Connected.<BR><BR>');
}

// REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE
print 'Dropping table PUBLICATIONS...';
$theSQL = "DROP TABLE PUBLICATIONS";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table USERS...';
$theSQL = "DROP TABLE USERS";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table MORPHOTYPE_CATEGORIES...';
$theSQL = "DROP TABLE MORPHOTYPE_CATEGORIES";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table IMAGES...';
$theSQL = "DROP TABLE IMAGES";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table MODERN_EXAMPLES...';
$theSQL = "DROP TABLE MODERN_EXAMPLES";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table CATEGORIES...';
$theSQL = "DROP TABLE CATEGORIES";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table MENUS...';
$theSQL = "DROP TABLE MENUS";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table SPECIMENS...';
$theSQL = "DROP TABLE SPECIMENS";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table MORPHOTYPES...';
$theSQL = "DROP TABLE MORPHOTYPES";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table COLLECTIONS...';
$theSQL = "DROP TABLE COLLECTIONS";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print 'Dropping table LOCALITIES...';
$theSQL = "DROP TABLE LOCALITIES";
$rs = $db->Execute($theSQL);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print "Done.<br>";
}
print '<br><hr><br>';
// REMOVE ABOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE REMOVE

# --------------------------------------------------------
# Create table MENUS
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='MENUS';
$flds = " 
 MENU_ID C(50) NOTNULL default 'MAIN' PRIMARY,
 MENU_TITLE C(120) NOTNULL,
 MENU_TEXT X
";
$taboptarray=array('mysql' => 'TYPE=InnoDB');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}

# --------------------------------------------------------
# Create table COLLECTIONS
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='COLLECTIONS';
$flds = " 
 COLLECTION_ID C(50) NOTNULL PRIMARY,
 CONTACT_NAME C(120),
 ADDRESS1 C(120),
 ADDRESS2 C(120),
 CITY C(60),
 STATE C(2),
 COUNTRY C(60) default 'USA',
 PHONE C(60),
 EMAIL C(60)
";
$taboptarray=array('mysql' => 'TYPE=InnoDB');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}

# --------------------------------------------------------
# Create table LOCALITIES
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='LOCALITIES';
$flds = " 
 LOC_NBR C(50) NOTNULL PRIMARY,
 LOC_NAME C(50) NOTNULL default '',
 LOC_DESCRIPTION C(200),
 LAND_OWNER C(50),
 COUNTY C(50),
 STATE C(50),
 GPS C(50),
 MAP_REFERENCE C(50),
 ERA C(50),
 EPOCH C(50),
 PERIOD C(50),
 LOCAL_AGE C(50),
 FORMATION_NAME C(50),
 MEMBER_NAME C(50),
 AGE_BEGIN C(50),
 AGE_END C(50),
 AGE_ESTIMATE C(50),
 TAXA X,
 NOTES X,
 RECORDED_BY C(50),
 RECORDED_DATE T,
 COLLECTION_YN C(1) NOTNULL default 'Y'
";
$taboptarray=array('mysql' => 'TYPE=InnoDB');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}

# --------------------------------------------------------
# Create table CATEGORIES
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='CATEGORIES';
$flds = " 
 MENU_ID C(50) NOTNULL default 'MAIN' PRIMARY,
 CATEGORY_ID C(100) NOTNULL default '' PRIMARY,
 CATEGORY_NAME C(200),
 OPTION_LEVEL I1 NOTNULL default '1',
 CATEGORY_DESC C(200),
 CATEGORY_IMAGE_LOC C(120) NOTNULL default '',
 SHOW_ALL_YN C(1) NOTNULL default 'Y'
";
$taboptarray=array('mysql' => 'TYPE=InnoDB','constraints' => ', FOREIGN KEY (MENU_ID) REFERENCES MENUS(MENU_ID) ON DELETE CASCADE ON UPDATE CASCADE');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}
print '&nbsp; - Creating Index...<br>';
$idxname='CATEGORY_ID';
$idxflds = 'CATEGORY_ID';
$sqlarray = $dict->CreateIndexSQL($idxname, $tabname, $idxflds);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

# --------------------------------------------------------
# Create table MODERN_EXAMPLES
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='MODERN_EXAMPLES';
$flds = " 
 MENU_ID C(50) NOTNULL default '' PRIMARY,
 CATEGORY_ID C(100) NOTNULL default '' PRIMARY,
 IMAGE_NBR I2 NOTNULL default '0',
 IMAGE_LOC C(150),
 IMAGE_CAPTION C(100),
 IMAGE_CREDIT C(100),
 IMAGE_COPYRIGHT C(100) C
";
$taboptarray=array('mysql' => 'TYPE=InnoDB','constraints' => ', FOREIGN KEY (MENU_ID, CATEGORY_ID) REFERENCES CATEGORIES(MENU_ID, CATEGORY_ID) ON DELETE CASCADE ON UPDATE CASCADE');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}

# --------------------------------------------------------
# Create table MORPHOTYPES
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='MORPHOTYPES';
$flds = " 
 MORPHOTYPE_NBR C(50) NOTNULL PRIMARY,
 GENUS_NAME C(50),
 SPECIES_NAME C(120),
 AUTHOR C(120),
 FAMILY C(120),
 THE_ORDER C(120),
 OLD_NAMES C(150),
 HIGHER_TAXON C(120),
 DIAGNOSTIC_FEATURES X,
 MORPHOTYPE_TEXT X,
 PUBLICATION_ID C(100),
 PUBLICATION_HELP C(75),
 RARITY_SCALE C(10),
 APPROVED_FOR_DISPLAY C(1) NOTNULL default 'Y',
 APPROVED_BY C(50),
 APPROVED_DATE D,
 LAST_UPDATE_DATE T
";
$taboptarray=array('mysql' => 'TYPE=InnoDB');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}

# --------------------------------------------------------
# Create table SPECIMENS
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='SPECIMENS';
$flds = "
 MORPHOTYPE_NBR C(50) NOTNULL default '' PRIMARY,
 SPECIMEN_NBR C(50) NOTNULL default 'MAIN' PRIMARY,
 SPECIMEN_CAT C(1) NOTNULL default 'H',
 ORGAN C(80),
 LOC_NBR C(50),
 COLLECTION_ID C(50),
 COLLECTED_BY C(80),
 COLLECTED_DATE C(10),
 SPECIMEN_TEXT X,
 ACQ_STATUS C(10) default 'OWN',
 ACQ_DATE C(10),
 ACQ_FROM C(80),
 ACQ_EXCHANGE C(80),
 APPROVED_FOR_DISPLAY C(1) NOTNULL default 'Y',
 APPROVED_BY C(50),
 APPROVED_DATE D,
 CREATED_BY C(50),
 CREATION_DATE D,
 LAST_UPDATE_DATE T NOTNULL
";
$taboptarray=array('mysql' => 'TYPE=InnoDB','constraints' => ', FOREIGN KEY (MORPHOTYPE_NBR) REFERENCES MORPHOTYPES(MORPHOTYPE_NBR) ON DELETE CASCADE ON UPDATE CASCADE');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}
print '&nbsp; - Creating Index...<br>';
$idxname='SPECIMENS_IDX1';
$idxflds = 'SPECIMEN_NBR';
$sqlarray = $dict->CreateIndexSQL($idxname, $tabname, $idxflds);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

print '&nbsp; - Creating Index...<br>';
$idxname='SPECIMENS_IDX2';
$idxflds = 'COLLECTION_ID';
$sqlarray = $dict->CreateIndexSQL($idxname, $tabname, $idxflds);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

print '&nbsp; - Creating Index...<br>';
$idxname='SPECIMENS_IDX3';
$idxflds = 'LOC_NBR';
$sqlarray = $dict->CreateIndexSQL($idxname, $tabname, $idxflds);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

# Note: couldn't put constraint above because the index on collection_id must be created first.
# Plus, couldn't get two foreign key constraints to work in CreateTableSQL() in $taboptarray.
print '&nbsp; - Creating Constraint...<br>';
$db->Execute("ALTER TABLE SPECIMENS ADD CONSTRAINT SPECIMENS_CON2 FOREIGN KEY (COLLECTION_ID) REFERENCES COLLECTIONS (COLLECTION_ID) ON DELETE CASCADE ON UPDATE CASCADE");
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }  

# Note: couldn't put constraint above because the index on loc_nbr must be created first.
# Plus, couldn't get two foreign key constraints to work in CreateTableSQL() in $taboptarray.
print '&nbsp; - Creating Constraint...<br>';
$db->Execute("ALTER TABLE SPECIMENS ADD CONSTRAINT SPECIMENS_CON3 FOREIGN KEY (LOC_NBR) REFERENCES LOCALITIES (LOC_NBR) ON DELETE CASCADE ON UPDATE CASCADE");
if ($db->ErrorMsg()) { print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

# --------------------------------------------------------
# Create table IMAGES
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='IMAGES';
$flds = " 
 MORPHOTYPE_NBR C(50) NOTNULL PRIMARY,
 SPECIMEN_NBR C(50) NOTNULL PRIMARY,
 IMAGE_TYPE C(2) NOTNULL PRIMARY,
 IMAGE_LOC C(150),
 IMAGE_CAPTION C(100),
 IMAGE_CREDIT C(100),
 IMAGE_COPYRIGHT C(100)
";
$taboptarray=array('mysql' => 'TYPE=InnoDB','constraints' => ', FOREIGN KEY (MORPHOTYPE_NBR, SPECIMEN_NBR) REFERENCES SPECIMENS(MORPHOTYPE_NBR, SPECIMEN_NBR) ON DELETE CASCADE ON UPDATE CASCADE');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}  
print '&nbsp; - Creating Index...<br>';
$idxname='IMAGES_IDX';
$idxflds = 'SPECIMEN_NBR,MORPHOTYPE_NBR';
$sqlarray = $dict->CreateIndexSQL($idxname, $tabname, $idxflds);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

# --------------------------------------------------------
# Create table MORPHOTYPE_CATEGORIES
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='MORPHOTYPE_CATEGORIES';
$flds = " 
 MORPHOTYPE_NBR C(50) NOTNULL PRIMARY,
 CATEGORY_ID C(100) NOTNULL PRIMARY,
 MENU_ID C(50) NOTNULL PRIMARY
";
$taboptarray=array('mysql' => 'TYPE=InnoDB', 'constraints' => ', FOREIGN KEY (MORPHOTYPE_NBR) REFERENCES MORPHOTYPES(MORPHOTYPE_NBR) ON DELETE CASCADE ON UPDATE CASCADE');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
//print_r($sqlarray);  # for debugging
//print "<BR><BR>";    # for debugging
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
    print '<br><b>'.$db->ErrorMsg().'</b><br>'; 
} else {
  print 'Done.<BR>';
}  

print '&nbsp; - Creating Index...<br>';
$idxname='MORPHOTYPE_CATEGORIES_IDX1';
$idxflds = 'CATEGORY_ID';
$sqlarray = $dict->CreateIndexSQL($idxname, $tabname, $idxflds);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

print '&nbsp; - Creating Index...<br>';
$idxname='MORPHOTYPE_CATEGORIES_IDX2';
$idxflds = 'MORPHOTYPE_NBR';
$sqlarray = $dict->CreateIndexSQL($idxname, $tabname, $idxflds);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

# Note: couldn't put constraint above because the index on category_id must be created first.
# Plus, couldn't get two foreign key constraints to work in CreateTableSQL() in $taboptarray.
print '&nbsp; - Creating Constraint...<br>';
if ($driver != 'mssql') {
  $db->Execute("ALTER TABLE MORPHOTYPE_CATEGORIES ADD CONSTRAINT MORPHOTYPE_CATEGORIES_CON1 FOREIGN KEY (CATEGORY_ID) REFERENCES CATEGORIES (CATEGORY_ID) ON DELETE CASCADE ON UPDATE CASCADE");
}
if ($db->ErrorMsg()) { print '<br><b>'.$db->ErrorMsg().'</b><br>'; }

# --------------------------------------------------------
# Create table PUBLICATIONS
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='PUBLICATIONS';
$flds = " 
 PUBLICATION_ID C(100) NOTNULL PRIMARY,
 AUTHORS C(100),
 PUBLICATION_TYPE C(20),
 TITLE X,
 YEAR I2 ,
 ISSUE C(30),
 PUBLICATION_NAME X,
 PUBLISHER_NAME C(60),
 PAGES C(15),
 COMMENTS X,
 DOCUMENT_LOCATION C(50) 
";
$taboptarray=array('mysql' => 'TYPE=InnoDB');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
  print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print 'Done.<BR>';
}  

# --------------------------------------------------------
# Create table USERS
# --------------------------------------------------------
$dict = NewDataDictionary($db);
$tabname='USERS';
$flds = " 
 USERNAME C(30) NOTNULL PRIMARY,
 PASSWORD C(30) NOT NULL,
 AUTHORIZATION_LEVEL I1,
 DESCRIPTION C(80),
 NAME C(80),
 PHONE C(12),
 EMAIL C(80)
";
$taboptarray=array('mysql' => 'TYPE=InnoDB');  # if mysql, add InnoDB type
print 'Creating table '.$tabname.'...';
$sqlarray = $dict->CreateTableSQL($tabname, $flds, $taboptarray);
if ($db->ErrorMsg()) {   print '<br><b>'.$db->ErrorMsg().'</b><br>'; }
$dict->ExecuteSQLArray($sqlarray);
if ($db->ErrorMsg()) { 
  print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print 'Done.<BR>';
}  

# ------------------------------------------------------------
# Required INSERTS for tables USERS, LOCALITIES & COLLECTIONS
# ------------------------------------------------------------

print '<BR>Inserting initial username "<b>admin</b>".  You should delete this user or change the password after creating your actual users...';
$sql = "INSERT INTO USERS VALUES ('admin', 'admin', 1, '', 'DELETE THIS ID', NULL, NULL);";
$db->Execute ($sql);
if ($db->ErrorMsg()) { 
  print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print 'Done.<BR>';
}  

print '<BR>Inserting generic collection id "<b>COLL1</b>". Use Admin Screens to insert your actual Collection IDs.';
$sql = "INSERT INTO COLLECTIONS VALUES ('COLL1','Contact Person','Address Line 1',NULL,'City','ST','USA','phone#','person@youraddress.com');";
$db->Execute ($sql);
if ($db->ErrorMsg()) { 
  print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print 'Done.<BR>';
}  

print '<BR>Inserting generic locality number "<b>LOC1</b>". Use Admin Screens to insert your actual Localities.';
$sql = "INSERT INTO LOCALITIES VALUES ('LOC1','Locality Name','Locality Description',NULL,NULL,'ST',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Y');";
$db->Execute ($sql);
if ($db->ErrorMsg()) { 
  print '<br><b>'.$db->ErrorMsg().'</b><br>';
} else {
  print 'Done.<BR>';
}  

print '<br><HR><BR>Done.<BR>';

?>

<?php

include ("include/footer.php");

?>
</body>
</html>