<?php
/***********************************************************************************
*  details.php                        Wagner Database Solutions, Inc.
*    v1.06 - 1 September 2004  (c) 2004 Steve Wagner.  All rights reserved.
*
*  Description:  This script shows the detail page of morphotypes, attachments, or
*                or other examples chosen on the menus.
*
*  Change Log:
*    v1.00   Initial beta release
*    v1.01   Don't display "View other specimens..." if it's an attachment category
*            and note to click on image for full size. (2/17/04)
*    v1.02   Added admin update ability for morphotype, specimen, images. (2/23/2004)
*    v1.03   Added urlencode() around Publication_ID in Source of Name so it would work
*            with Netscape. (3/7/04)
*    v1.04   Added $table_background_color variable. (5/7/04)
*    v1.05   Added use of specimen_nbr passed parameter.  Also added descriptive 
*            specimen_cat display (8/26/04)
*    v1.06   Added rtrim() of locality, acquired_from, collected_by, collected_date,
*            old_names and state.  If they aren't present, don't display them. (9/1/04)
*
************************************************************************************/
include_once ("./include/config.php");
include_once ("./include/header.php");
?>

<html>
<body>

<script language="JavaScript" type="text/JavaScript">
<!--
function window_popup (winName, theVars) {
  if (winName == 'Update_Morphotype' || winName == 'Update_Specimen' || winName == 'Update_Images') {
    alert ('Note: After updating in new window, refresh Details page to see changes.');
    var features = 'scrollbars=yes,resizable=yes,menubar=yes,location=yes,toolbar=yes,directories=yes';
    var theURL = theVars + '';
  } else if (winName == 'Locality') {
    var theURL = 'localities.php?loc_nbr=' + theVars + '';
    var features = 'scrollbars=yes,resizable=yes,width=350,height=550';
  } else {
    var theURL = 'bibliography.php?publication_id=' + theVars + '';
	var features = 'scrollbars=yes,resizable=yes,width=750,height=150';
  }
  newwindow = window.open (theURL, winName, features);
  if (window.focus) {newwindow.focus()}
  return false;
}
//-->
</script>

<?php

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver); 
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

if ($morphotype_nbr =='') {
  print "<br><b>Error: No morphotype nbr given!</b><br>";
} else {
  print "<center><b><font class=pch>Morphotype Details</font></b></center><br>";
}

// If specimen_nbr was passed, then use it to build query where condition.
if ($specimen_nbr !='') {
  $specimen_query = " AND SPECIMENS.SPECIMEN_NBR = '$specimen_nbr'";
}

$rs = $db->Execute("SELECT MORPHOTYPES.MORPHOTYPE_NBR, MORPHOTYPES.GENUS_NAME, MORPHOTYPES.SPECIES_NAME,
                           MORPHOTYPES.AUTHOR, MORPHOTYPES.FAMILY, MORPHOTYPES.THE_ORDER, 
						   MORPHOTYPES.OLD_NAMES, MORPHOTYPES.HIGHER_TAXON, MORPHOTYPES.DIAGNOSTIC_FEATURES,
						   MORPHOTYPES.MORPHOTYPE_TEXT, MORPHOTYPES.PUBLICATION_ID, MORPHOTYPES.PUBLICATION_HELP,
						   MORPHOTYPES.RARITY_SCALE, 
						   SPECIMENS.SPECIMEN_NBR, SPECIMENS.SPECIMEN_CAT, SPECIMENS.ORGAN, SPECIMENS.LOC_NBR,
						   SPECIMENS.COLLECTION_ID, SPECIMENS.COLLECTED_BY, SPECIMENS.COLLECTED_DATE,
						   SPECIMENS.SPECIMEN_TEXT, SPECIMENS.ACQ_STATUS, SPECIMENS.ACQ_DATE, 
						   SPECIMENS.ACQ_FROM, SPECIMENS.ACQ_EXCHANGE
                    FROM MORPHOTYPES, SPECIMENS
                    WHERE MORPHOTYPES.MORPHOTYPE_NBR = SPECIMENS.MORPHOTYPE_NBR AND
                          MORPHOTYPES.APPROVED_FOR_DISPLAY = 'Y' AND
						  SPECIMENS.SPECIMEN_CAT = '$specimen_cat' AND
						  MORPHOTYPES.MORPHOTYPE_NBR = '$morphotype_nbr' " . $specimen_query . ";");

if ($rs->EOF) {
  print "<form><br><b>Error: Morphotypes number $morphotype_nbr not found!</b>&nbsp;&nbsp;&nbsp;";
  print "<input type=\"button\" value=\"GO BACK\" onClick=\"window.history.go(-1)\"></form>";
} else {

  /* Get IMAGES: D=Detail; DF=DetailFull; 1,2,3 = special details */
  $rs_d = $db->Execute("SELECT IMAGE_LOC, IMAGE_CAPTION FROM IMAGES WHERE MORPHOTYPE_NBR = '".$rs->fields["MORPHOTYPE_NBR"]."' AND SPECIMEN_NBR = '".$rs->fields["SPECIMEN_NBR"]."' AND IMAGE_TYPE ='D';");
  $img_d = $rs_d->fields["IMAGE_LOC"];
  $img_d_cap = $rs_d->fields["IMAGE_CAPTION"];
  
  $rs_df = $db->Execute("SELECT IMAGE_LOC, IMAGE_CAPTION FROM IMAGES WHERE MORPHOTYPE_NBR = '".$rs->fields["MORPHOTYPE_NBR"]."' AND SPECIMEN_NBR = '".$rs->fields["SPECIMEN_NBR"]."' AND IMAGE_TYPE ='DF';");
  $img_df_cap = $rs_df->fields["IMAGE_CAPTION"];
  $img_df = $rs_df->fields["IMAGE_LOC"];

  $rs_1 = $db->Execute("SELECT IMAGE_LOC, IMAGE_CAPTION FROM IMAGES WHERE MORPHOTYPE_NBR = '".$rs->fields["MORPHOTYPE_NBR"]."' AND SPECIMEN_NBR = '".$rs->fields["SPECIMEN_NBR"]."' AND IMAGE_TYPE ='1';");
  $img_1 = $rs_1->fields["IMAGE_LOC"];
  $img_1_cap = $rs_1->fields["IMAGE_CAPTION"];

  $rs_2 = $db->Execute("SELECT IMAGE_LOC, IMAGE_CAPTION FROM IMAGES WHERE MORPHOTYPE_NBR = '".$rs->fields["MORPHOTYPE_NBR"]."' AND SPECIMEN_NBR = '".$rs->fields["SPECIMEN_NBR"]."' AND IMAGE_TYPE ='2';");
  $img_2 = $rs_2->fields["IMAGE_LOC"];
  $img_2_cap = $rs_2->fields["IMAGE_CAPTION"];

  $rs_3 = $db->Execute("SELECT IMAGE_LOC, IMAGE_CAPTION FROM IMAGES WHERE MORPHOTYPE_NBR = '".$rs->fields["MORPHOTYPE_NBR"]."' AND SPECIMEN_NBR = '".$rs->fields["SPECIMEN_NBR"]."' AND IMAGE_TYPE ='3';");
  $img_3 = $rs_3->fields["IMAGE_LOC"];
  $img_3_cap = $rs_3->fields["IMAGE_CAPTION"];

  /* Fetch & display them in a table */
  print "<table  bgcolor=".$table_background_color." WIDTH=\"80%\" align=\"center\" border=\"0\" cellpadding=\"5\"  class=\"results\">";

  print "<tr>";
  $i = 0;
  while (!$rs->EOF) {

    if ($specimen_cat == 'H') {
      $spec_cat = "Holomorphotype";
    } elseif ($specimen_cat == 'A'){
      $spec_cat = "Attachment";
    } elseif ($specimen_cat == 'O'){
      $spec_cat = "Other";
    } elseif ($specimen_cat == 'T'){
      $spec_cat = "Type Suite";
	} else {
	  $spec_cat = $specimen_cat;
	}

    print "<table WIDTH=\"100%\" align=\"center\" border=\"0\" cellpadding=\"5\">";
    print "<tr valign=top halign=left>";
    print "<td>";
    print "<a href=".$img_df.">";
    print "<img border=2 NOSAVE src=".$img_d."></a><br><center>Click image to view larger version.</center><br><br>";
	if ($img_1 != '') {
      print "<img border=1 NOSAVE src=".$img_1."><br><font size=-1><b>".$img_1_cap."</b></font><br><br>";
	}
	if ($img_2 != '') {
  	  print "<img border=1 NOSAVE src=".$img_2."><br><font size=-1><b>".$img_2_cap."</b></font><br><br>";
	}
	if ($img_3 != '') {
      print "<img border=1 NOSAVE src=".$img_3."><br><font size=-1><b>".$img_3_cap."</b></font><br><br>";
	}
	print "</td>";

    // Retrieve locality information  
    $rs_loc = $db->Execute("SELECT LOC_NAME, STATE FROM LOCALITIES WHERE LOC_NBR = '".$rs->fields["LOC_NBR"]."' ;");

    print "<td width=\"80%\" valign=\"top\" halign=\"left\">";

    print "<b>Morphotype:</b>&nbsp;".$rs->fields["MORPHOTYPE_NBR"]."<br><br>";
    print "<b>Name (Author):</b>&nbsp;<i>".$rs->fields["GENUS_NAME"]." ".$rs->fields["SPECIES_NAME"]."</i> ".$rs->fields["AUTHOR"]."<br><br>";
    print "<b>Organ:</b>&nbsp;".$rs->fields["ORGAN"]."<b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Rarity:</b>&nbsp;".$rs->fields["RARITY_SCALE"]."<br><br>";
    print "<b>Family:</b>&nbsp;".$rs->fields["FAMILY"]."&nbsp;&nbsp;&nbsp;<b>Order:</b>&nbsp;".$rs->fields["THE_ORDER"]."<br><br>";
    print "<b>Specimen #:</b>&nbsp;".$rs->fields["SPECIMEN_NBR"]."&nbsp;&nbsp;&nbsp;<b>Category:</b>&nbsp;".$spec_cat."<br><br>";
    print "<b>Diagnostic Features:</b><br>".$rs->fields["DIAGNOSTIC_FEATURES"]."<br><br>";
	if (rtrim($rs->fields["OLD_NAMES"]) != '') {
      print "<b>Old Name(s):</b>&nbsp;".$rs->fields["OLD_NAMES"]."<br><br>";
	}
    print "<b>Higher Taxon:</b>&nbsp;".$rs->fields["HIGHER_TAXON"]."<br><br>";

    print "<b>Source of Name:</b>&nbsp;<a href=\"javascript: ; \" onClick=\"javascript: window_popup('Publications', '".urlencode($rs->fields["PUBLICATION_ID"]). "');\">"
	       .$rs->fields["PUBLICATION_ID"]."</a><br><br>";
    print "<b>Publication Pages:</b>&nbsp;".$rs->fields["PUBLICATION_HELP"]."<br><br>";
	$x_collected = "<b>Collected By: ";
    $x_collected_by = rtrim($rs->fields["COLLECTED_BY"]);
	if ($x_collected_by != '') {
	  $x_collected = $x_collected."</b>&nbsp;".$x_collected_by;
	}
    $x_collected_date = rtrim($rs->fields["COLLECTED_DATE"]);
	if ($x_collected_date != '') {
	  $x_collected = $x_collected.",&nbsp;".$x_collected_date;
	}
	print $x_collected."<br><br>";
    print "<b>Collection ID:</b>&nbsp;".$rs->fields["COLLECTION_ID"]."<br><br>";
    $x_state = rtrim($rs->fields["STATE"]);
	if ($x_state == '') {
	  $x_state = '';
	} else {
	  $x_state = ", ".rtrim($rs->fields["STATE"]);
	}
	if ($aLogin) {  // authorized user.  This is a session variable defined in login.php
	  
      print "<b>Locality #:</b>&nbsp;<a href=\"javascript: ; \" onClick=\"javascript: window_popup('Locality', '" .$rs->fields["LOC_NBR"]. "');\">"
	        .$rs->fields["LOC_NBR"]."</a> - ".$rs_loc->fields["LOC_NAME"].$x_state."<br><br>";
	} elseif ($x_state == '') {  // public no state
      print '';
	} elseif ($x_state != '') {  // public with state
      print "<b>State:</b>&nbsp;".$x_state."<br><br>";
	}
// Need to add check! ********************************************************************************************************
    print "<b>Morphotype Description:</b><br>".$rs->fields["MORPHOTYPE_TEXT"]."<br><br>";
	if ($rs->fields["ACQ_STATUS"] != 'OWN') {
      print "<b>Acquisition Status:</b>&nbsp;".$rs->fields["ACQ_STATUS"]."<br><br>";
    }
	if (rtrim($rs->fields["ACQ_FROM"]) != '') {
      print "<b>Acquired From:</b>&nbsp;".$rs->fields["ACQ_FROM"]."<br><br>";
	}
	print "<b>Comments:</b><br>".$rs->fields["SPECIMEN_TEXT"]."<br><br>";
	if ( $specimen_cat != 'A' ) { # Don't want view other specimens if it's an attachment with fake morphotype # that will never be found.
      print "<a href=\"thumbs_match.php?morph_match=".$rs->fields["MORPHOTYPE_NBR"]."\">View other specimens of this morphotype</a><br><br>";
	}
	
    if ($aLogin) {  // authorized user.  This is a session variable defined in login.php
	print "<b>UPDATE:&nbsp;&nbsp;<a href=\"javascript: ; \" onClick=\"javascript: window_popup('Update_Morphotype', 'admin_morphotypes.php?morphotype_nbr=" 
	      .$rs->fields["MORPHOTYPE_NBR"]. "');\">[Morphotype]</a>&nbsp;&nbsp;";
	print "<a href=\"javascript: ; \" onClick=\"javascript: window_popup('Update_Specimen', 'admin_specimens.php?morphotype_nbr=" 
	      .$rs->fields["MORPHOTYPE_NBR"]. "&specimen_nbr=" .$rs->fields["SPECIMEN_NBR"]. "');\">[Specimen]</a>&nbsp;&nbsp;";
	print "<a href=\"javascript: ; \" onClick=\"javascript: window_popup('Update_Images', 'admin_images.php?morphotype_nbr=" 
	      .$rs->fields["MORPHOTYPE_NBR"]. "&specimen_nbr=" .$rs->fields["SPECIMEN_NBR"]. "');\">[Images]</a></b>";	
	}
    	
    print "</td></tr></table>";

    $rs->MoveNext();

    print "</tr>";
    print "</table>";

  }

}

/****************************************************************************/

include ("./include/footer.php");

?>

</body>
</html>
