<?php
/***********************************************************************************
*  config.php                        Wagner Database Solutions, Inc.
*    v1.10 - 21 Sept 2005  (c) 2004 Steve Wagner.  All rights reserved.
*
*  Description:  This file contains special configuration variables for PaleoCollaborator.
*
*  Change Log:
*    v1.0   Initial beta release
*    v1.01  Added $uploaddir & $submittal_email_addresses.
*    v1.02  Added $attachments_ok variable.  Attachments seem to work fine in non-firewall
*           environments, but didn't work at DMNS.
*    v1.03  Added admin menu navigation
*    v1.04  Split $uploaddir to make that and $home_on_drive (needed for Windows O/S), 2/18/04
*    v1.05  Added $menu_admin_0_url. (2/24/2004)
*    v1.06  Changed from v1.1 to v1.2.
*    v1.07  ...
*    v1.08  Increased image upload size from 2000000 to 5MBytes (5120000). (10/21/2004, sbw)
*    v1.09  ...
*    v1.10  Changed from v1.2 to v1.2.2 (9/21/05)
*
************************************************************************************/

// Org_logo_image is used as the image in the header.
$org_logo_image = "images/dmns_logo.gif";

// Org_name used as cursor help on header logo
$org_name = "Your institution here";

// Copyright notice used in footer.
$copyright_notice = "Your institution here, 2005. All rights reserved.";

// Org_home_url used as link for header logo.
$org_home_url = "http://www.yoursite.com";

//******************************************************************************************
//  $attachments_ok.  Some environments don't handle email attachments well from the
//  hosting server.  This was the case under Windows/Cisco at DMNS.  If you set 
//  this variable to 0, then URLs will be substituted for attachments in the emails.
//  As a suggestion, try setting this variable to 1 first.  If the attachments do not
//  come through or are unreadable as images, set it to 0.
//$attachments_ok = 0;
$attachments_ok = 1;

//  Server directory where temp image files that are submitted reside.  This MUST agree
//  with the above $attachments_ok setting.  If attachments aren't O.K, then the upload
//  directory must name the "Uploads" directory.  $home_on_drive is only needed on Windows
//  systems to specify the physical system home on a drive.
//  $uploaddir = '\Uploads\\'; # Windows
$uploaddir = '/tmp/';  # use tmp dir on Unix, Linux
//$home_on_drive = 'F:\PaleoCollaborator\\';  # Must be defined for file upload on Windows O/S.
$home_on_drive = '';  #null, not needed on Unix, Linux

//******************************************************************************************

// window_title is used for the title of the browser window.
$window_title = "PaleoCollaborator";

// submittals are emailed to the following addresses.  Separate addresses with commas.
//$submittal_email_addresses = "paleo@paleocurrents.com";
//$submittal_email_addresses = "swagner@dmns.org";
$submittal_email_addresses = "you@yoursite.com, another@yoursite.com";

// header_background_color is the area to the right of the logo in the header.
$header_background_color = "#000000";

// page_background_color is used as the background color of every page.
$page_background_color = "white";

// table_background_color is used in most pages as the table background color.
$table_background_color = "FFFFFF";

// pc_home_url used as link to PaleoCollaborator home.
$pc_home_url = "http://www.paleocurrents.com/docs/paleocollaborator.html";

$pc_version = "1.2.2";

// *******************************************************************
$background_header = "background.php?header='STATIC'&page=";
// *******************************************************************

$menu_main_1_url = "index.php";
$menu_main_1_title = "Project Home";

$menu_main_2_url = "menu.php";
$menu_main_2_title = "Identification";

$menu_main_3_url = $background_header . "background1.html";
$menu_main_3_title = "Project Background";

$menu_main_4_url = "bibliography.php";
$menu_main_4_title = "Bibliography";

$menu_main_5_url = "contact.php";
$menu_main_5_title = "Contact";

$menu_main_6_url = "submittal.php";
$menu_main_6_title = "Submit Fossils";

$menu_main_7_url = "search.php";
$menu_main_7_title = "Quick Search";

// *******************************************************************
$menu_background_1_url = "index.php";
$menu_background_1_title = "Project Home";

$menu_background_2_url = $background_header . "background1.html";
$menu_background_2_title = "The Project";

$menu_background_3_url = $background_header . "background2.html";
$menu_background_3_title = "Identifying &amp Naming New Species";

$menu_background_4_url = $background_header . "background3.html";
$menu_background_4_title = "Morphotyping";

$menu_background_5_url = $background_header . "background4.html";
$menu_background_5_title = "Leaf Description &amp ID Tools";

$menu_background_6_url = $background_header . "background5.html";
$menu_background_6_title = "Credits &amp Links";

$menu_background_7_url = "search.php";
$menu_background_7_title = "Quick Search";

// *******************************************************************

$menu_admin_0_url = "index.php";
$menu_admin_0_title = "Public Screens";

$menu_admin_1_url = "admin_morphotypes.php";
$menu_admin_1_title = "Morphotypes";

$menu_admin_2_url = "admin_specimens.php";
$menu_admin_2_title = "Specimens";

$menu_admin_3_url = "admin_images.php";
$menu_admin_3_title = "Images";

$menu_admin_4_url = "admin_collections.php";
$menu_admin_4_title = "Collections";

$menu_admin_5_url = "admin_modern_examples.php";
$menu_admin_5_title = "Modern";

$menu_admin_6_url = "admin_users.php";
$menu_admin_6_title = "Users";

$menu_admin_7_url = "admin_locality.php";
$menu_admin_7_title = "Localities";

$menu_admin_8_url = "admin_menus.php";
$menu_admin_8_title = "Menus";

$menu_admin_9_url = "admin_categories.php";
$menu_admin_9_title = "Categories";

$menu_admin_10_url = "admin_morphotype_categories.php";
$menu_admin_10_title = "Morphotype Categories";

$menu_admin_11_url = "admin_publications.php";
$menu_admin_11_title = "Publications";

// *******************************************************************

$largest_image_size = "5120000"; // for uploading to email
?>