<?php
/***********************************************************************************
*  load_morphotype_master.php                        Wagner Database Solutions, Inc.
*    v1.01 - 3 Feb 2004  (c) 2004 Steve Wagner.  All rights reserved.
*            See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  This script is used to load numerous base tables: MENUS, CATEGORIES,
*     MODERN_EXAMPLES, PUBLICATIONS from their related Excel csv files.
*
*  Change Log:
*    v1.0   Initial beta release
*    v1.01  Added test for SQL Server ErrorNo() 2627 because "Duplicate" wasn't 
*           appearing in ErrorMsg().
*
************************************************************************************/

include_once ("./include/config.php");
include_once ("./include/header.php");
?>
<html>
<body>

<?php

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver); 
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

function print_error($text)
{
  print $text;
  return;
}

if ($table=='') {
  print_error ("Error: No tablename specified to load!");
} else if ($filename=='') {
  print_error ("Error: No filename specified to load!");
} else {

   print "<br><b>Loading Table:" . $table . ", with File: " . $filename . "</b><br>\n";

   $handle = fopen ("data_import/$filename","r");

   /* get and ignore row 1 because it is the header in the CSV file */
   $data = fgetcsv ($handle, 1000, ",");

   $row = 1;
   while ($data = fgetcsv ($handle, 1000, ",")) {
     $num = count ($data);
     $row++;

     if ($table=='MENUS') {
       /*  INSERT MENUS ROW */
       $sql = "INSERT INTO MENUS (MENU_ID, MENU_TITLE, MENU_TEXT) VALUES (";
       $sql .= " \"$data[0]\",\"$data[1]\",\"$data[2]\")";

       if ($db->Execute($sql) === false) {
         if (strrchr($db->ErrorMsg(), 'Duplicate' ) or ($db->ErrorNo()=='2627' ) ) { // 2627 is mssql error #
	       print 'Duplicate MENUS: ['.$db->ErrorMsg().'].  Attempting Update...  ';
           /*  UPDATE MENUS ROW */
           $sql  = "UPDATE MENUS SET MENU_TITLE = \"$data[1]\", MENU_TEXT = \"$data[2]\" ";
           $sql .= "WHERE MENU_ID = \"$data[0]\"; ";
           if ($db->Execute($sql) === false) {
             print "sql: " . $sql . "<br><br>\n";
   	         print 'Error updating MENUS: ['.$db->ErrorMsg().'].<BR><BR>';
 	       } else {
	         print "worked!<br><br>\n";
	       }
         } else {
           print "sql: " . $sql . "<br><br>\n";
	       print 'Error inserting MENUS: ['.$db->ErrorMsg().'].<BR><BR>';
         }
       }

	 } else if ($table=='CATEGORIES') {
       /*  INSERT CATEGORIES ROW */
       $sql = "INSERT INTO CATEGORIES (MENU_ID, OPTION_LEVEL, CATEGORY_ID, CATEGORY_NAME, ";
	   $sql .= "CATEGORY_DESC,CATEGORY_IMAGE_LOC, SHOW_ALL_YN) VALUES ( ";
       $sql .= " \"$data[0]\",\"$data[1]\",\"$data[2]\",\"$data[3]\",\"$data[4]\",\"$data[5]\",\"$data[6]\")";

       if ($db->Execute($sql) === false) {
         if (strrchr($db->ErrorMsg(), 'Duplicate' ) or ($db->ErrorNo()=='2627' ) ) { // 2627 is mssql error #
	       print 'Duplicate CATEGORIES: ['.$db->ErrorMsg().'].  Attempting Update... ';
           /*  UPDATE CATEGORIES ROW */
           $sql  = "UPDATE CATEGORIES SET OPTION_LEVEL = \"$data[1]\", CATEGORY_NAME = \"$data[3]\", ";
           $sql .= "CATEGORY_DESC = \"$data[4]\", CATEGORY_IMAGE_LOC = \"$data[5]\", SHOW_ALL_YN = \"$data[6]\" ";
           $sql .= "WHERE MENU_ID = \"$data[0]\" AND CATEGORY_ID = \"$data[2]\"; ";
           if ($db->Execute($sql) === false) {
             print "sql: " . $sql . "<br><br>\n";
   	         print 'Error updating CATEGORIES: ['.$db->ErrorMsg().'].<BR><BR>';
 	       } else {
	         print "worked!<br><br>\n";
	       }		 
		 } else {
           print "sql: " . $sql . "<br><br>\n";
	       print 'Error inserting CATEGORIES: ['.$db->ErrorMsg().'].<BR><BR>';
         }
       }

	 } else if ($table=='MODERN_EXAMPLES') {
       /*  INSERT MODERN_EXAMPLES ROW */
       $sql = "INSERT INTO MODERN_EXAMPLES (MENU_ID,CATEGORY_ID, IMAGE_NBR, IMAGE_LOC, IMAGE_CAPTION, IMAGE_CREDIT, ";
	   $sql .= "IMAGE_COPYRIGHT) VALUES ( ";
       $sql .= "\"$data[0]\",\"$data[1]\",\"$data[2]\",\"$data[3]\",\"$data[4]\",\"$data[5]\",\"$data[6]\")";

       if ($db->Execute($sql) === false) {
         if (strrchr($db->ErrorMsg(), 'Duplicate' ) or ($db->ErrorNo()=='2627' ) ) { // 2627 is mssql error #
	       print 'Duplicate MODERN_EXAMPLES: ['.$db->ErrorMsg().'].  Attempting Update... ';
           /*  UPDATE MODERN_EXAMPLES ROW */
           $sql  = "UPDATE MODERN_EXAMPLES SET IMAGE_NBR = \"$data[2]\", IMAGE_LOC = \"$data[3]\", ";
           $sql .= "IMAGE_CAPTION = \"$data[4]\", IMAGE_CREDIT = \"$data[5]\", IMAGE_COPYRIGHT = \"$data[6]\" ";
           $sql .= "WHERE MENU_ID = \"$data[0]\" AND CATEGORY_ID = \"$data[1]\"; ";
           if ($db->Execute($sql) === false) {
             print "sql: " . $sql . "<br><br>\n";
   	         print 'Error updating MODERN_EXAMPLES: ['.$db->ErrorMsg().'].<BR><BR>';
 	       } else {
			 print "worked!<br><br>\n";
	       }		 
		 } else {
           print "sql: " . $sql . "<br><br>\n";
	       print 'Error inserting MODERN_EXAMPLES: ['.$db->ErrorMsg().'].<BR><BR>';
         }
       }

	 } else if ($table=='PUBLICATIONS') {
       /*  INSERT PUBLICATIONS ROW */
	   $sql = "INSERT INTO PUBLICATIONS ( PUBLICATION_ID , AUTHORS , PUBLICATION_TYPE , TITLE , YEAR , ";
	   $sql .= "ISSUE , PUBLICATION_NAME , PUBLISHER_NAME , PAGES , COMMENTS , DOCUMENT_LOCATION ) VALUES ( ";
       $sql .= " \"$data[0]\", \"$data[1]\" , \"$data[2]\" , \"$data[3]\" , \"$data[4]\" , \"$data[5]\", ";
       $sql .= " \"$data[6]\", \"$data[7]\" , \"$data[8]\" , \"$data[9]\" , \"$data[10]\" )";

       if ($db->Execute($sql) === false) {
         if (strrchr($db->ErrorMsg(), 'Duplicate' ) or ($db->ErrorNo()=='2627' ) ) { // 2627 is mssql error #
	       print 'Duplicate PUBLICATIONS: ['.$db->ErrorMsg().'].  Attempting Update... ';
           
		   /*  UPDATE PUBLICATIONS ROW */
		   $sql  = "UPDATE PUBLICATIONS SET AUTHORS = \"$data[1]\", PUBLICATION_TYPE = \"$data[2]\" , ";
           $sql .= "TITLE = \"$data[3]\" , YEAR = \"$data[4]\" , ISSUE = \"$data[5]\" , PUBLICATION_NAME = \"$data[6]\" , ";
           $sql .= "PUBLISHER_NAME = \"$data[7]\" , PAGES = \"$data[8]\" , COMMENTS = \"$data[9]\" , ";
           $sql .= "DOCUMENT_LOCATION = \"$data[10]\" WHERE PUBLICATION_ID = \"$data[0]\" "; 
           if ($db->Execute($sql) === false) {
             print "sql: " . $sql . "<br><br>\n";
   	         print 'Error updating PUBLICATIONS: ['.$db->ErrorMsg().'].<BR><BR>';
 	       } else {
			 print "worked!<br><br>\n";
	       }		 
		 } else {
           print "sql: " . $sql . "<br><br>\n";
	       print 'Error inserting PUBLICATIONS: ['.$db->ErrorMsg().'].<BR><BR>';
         }
       }
	 
	 } else {
       print_error ("Error: Invalid tablename to load!");
	   break;
	 }

   }
   fclose ($handle);

}

/****************************************************************************/

include ("./include/footer.php");

?>

</body>
</html>
