<?php
/***********************************************************************************
*  localities.php                        Wagner Database Solutions, Inc.
*    v1.0 - 4 Mar 2004  (c) 2004 Steve Wagner.  All rights reserved.
*           See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Displays the entire list of localities if called from
*                the navigation tabs.  If called from the Details screen, only
*                displays the single locality.  This option on the Details screen is
*                only available for authorized users who are logged in.
* 
*  Change Log:
*    v1.0   Initial beta release. (3/4/2004)
*
************************************************************************************/
include_once ("./include/config.php");
if (!$loc_nbr) {
  include_once ("./include/header.php");
} else {
  include_once ("./include/header_small.php");
}
?>
<html>
<body>

<?php

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver); 
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

$sql =  "SELECT LOC_NBR, LOC_NAME, LOC_DESCRIPTION, LAND_OWNER, COUNTY, STATE, GPS, MAP_REFERENCE, ERA, EPOCH, PERIOD, ";
$sql .=        "LOCAL_AGE, FORMATION_NAME, MEMBER_NAME, AGE_BEGIN, AGE_END, AGE_ESTIMATE, TAXA, NOTES ";
$sql .= "FROM LOCALITIES ";

if ( $loc_nbr ) {
  $sql .= "WHERE loc_nbr = \"" . $loc_nbr . "\";";
} else {
  print "<center><b><font class=pch>Localities</font></b></center><br>";
  $sql .= "ORDER BY LOC_NBR;";
}

$rs = $db->Execute($sql);

if ($rs->EOF) {
  print "<form><br><b>No localities found for your selection.</b>&nbsp;&nbsp;&nbsp;";
  print "<input type=\"button\" value=\"GO BACK\" onClick=\"window.history.go(-1)\"></form>";
} else {

  while (!$rs->EOF) {

    print "<table WIDTH=\"95%\" align=\"center\" border=\"0\" cellpadding=\"5\">";
    print "<tr valign=top halign=left>";

    print "<td width=\"80%\" valign=\"top\" halign=\"left\">";

    print "Locality #: <b>". $rs->fields["LOC_NBR"]."</b><br>".
	      "Locality Name: <b>".$rs->fields["LOC_NAME"]."</b><br>".
	      "Locality Description: <b>".$rs->fields["LOC_DESCRIPTION"]."</b><br>".
		  "Land Owner: <b>".$rs->fields["LAND_OWNER"]."</b><br>".
		  "County: <b>".$rs->fields["COUNTY"]."</b><br>".
		  "State: <b>".$rs->fields["STATE"]."</b><br>".
          "GPS: <b>".$rs->fields["GPS"]."</b><br>".
          "Map Reference: <b>".$rs->fields["MAP_REFERENCE"]."</b><br>".
		  "Era: <b>".$rs->fields["ERA"]."</b><br>".
          "Epoch: <b>".$rs->fields["EPOCH"]."</b><br>".
		  "Period: <b>".$rs->fields["PERIOD"]."</b><br>".
	      "Age: <b>".$rs->fields["LOCAL_AGE"]."</b><br>".
          "Formation: <b>".$rs->fields["FORMATION_NAME"]."</b><br>".
          "Member: <b>".$rs->fields["MEMBER_NAME"]."</b><br>".
          "Age Begin: <b>".$rs->fields["AGE_BEGIN"]."</b><br>".
          "Age End: <b>".$rs->fields["AGE_END"]."</b><br>".
	      "Age Estimate: <b>".$rs->fields["AGE_ESTIMATE"]."</b><br>".
	      "Notes: <b>".$rs->fields["NOTES"]."</b><br><br>";

    print "</td></tr></table><br>";

    $rs->MoveNext();

  }

}

/****************************************************************************/
if (!$loc_nbr) {
  include ("./include/footer.php");
} else {
  print "<center><a href=javascript:close();>Close Window</a>";
}

?>

</body>
</html>