<?php
/***********************************************************************************
*  menu.php                        Wagner Database Solutions, Inc.
*    v1.1 - 22 Mar 2004  (c) 2004 Steve Wagner.  All rights reserved.
*           See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  This script recursively calls itself to display all the menus in 
*                PaleoCollaborator.  With each successive call, it takes the chosen
*                option & calls itself again to display the next lower level.
* 
*  Change Log:
*    v1.0   Initial beta release. (3/4/2004)
*    v1.1   Fix to handle modern images with spaces in filenames in Netscape.
*
************************************************************************************/
include_once ("./include/config.php");
include_once ("./include/header.php");
?>
<html>
<body>

<?php
$page='MENU';

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver);
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

function try_thumbs($try)
{
  print "<br><b>No new menu found. Try going to fossil thumbnails: <a href=thumbs.php?category_id=$try>$try</a></b>"; 
  return;
}

if ($menu=='') {
  $menu='MAIN';
}

$rs = $db->Execute("SELECT MENU_ID, MENU_TITLE, MENU_TEXT FROM MENUS WHERE MENU_ID = '$menu'");

if ($rs->EOF) {
  /*  No menu found, so try thumbnails page using the "menu" id passed in. This should never happen because 
  *   the menu has already been verified in previous menu.php call.  */
  try_thumbs ($menu);
  exit;
} else {
  print "<center><b><font class=pch>".$rs->fields["MENU_TITLE"]."</font></b><br><br>".$rs->fields["MENU_TEXT"]."</center><br>";
}

/****************************************************************************/

  $query="SELECT MENU_ID,
                 CATEGORY_ID,
                 CATEGORY_NAME,
                 CATEGORY_DESC,
                 OPTION_LEVEL,
                 SHOW_ALL_YN,
                 CATEGORY_IMAGE_LOC
          FROM   CATEGORIES
          WHERE  MENU_ID = '$menu'
          ORDER BY OPTION_LEVEL";

$rs = $db->Execute($query);

if ($rs->EOF) {
  print "<br><b>Error: $menu menu options not found!</b><br>";
  try_thumbs($menu);
} else {

  /* Fetch & display them in a table */
  print "<table WIDTH=\"80%\" align=\"center\" border=\"0\" bordercolor=\"$table_background_color\" cellpadding=\"5\"  class=\"results\">";

  while (!$rs->EOF) {

    /*  See if there is a menu for the category_id.  If not, make hyperlink call thumbs.php */
    $sql_stmt = "SELECT MENU_ID, MENU_TITLE, MENU_TEXT FROM MENUS WHERE MENU_ID = '".$rs->fields["CATEGORY_ID"]."'";
    $next_rs = $db->Execute($sql_stmt);  /* Note $next_rs, not $rs */
    if ($next_rs->EOF) {
      $href_tag       = "<a href=thumbs.php?category_id=".$rs->fields["CATEGORY_ID"].">";
    } else {
      $href_tag       = "<a href=menu.php?menu=".$rs->fields["CATEGORY_ID"].">";
    }	
    $href_menu      = $href_tag;
    $href_menu_name = $href_tag.$rs->fields["CATEGORY_NAME"]."</a>";
 
    if ($rs->fields["SHOW_ALL_YN"]=='Y') {
	  $href_thumbs = "<a href=thumbs.php?category_id=".$rs->fields["CATEGORY_ID"]."&query=show_all>(Show All)</a>";
	} else {
	  $href_thumbs = "";  /* Show all not allowed at this menu level. */
	}
	
    print "<tr bgcolor=\"$table_background_color\" ><td valign=\"top\" halign=\"left\">".$href_menu.
          "<img border=\"0\" src=\"".$rs->fields["CATEGORY_IMAGE_LOC"]."\"></a></td>"; 

    print "<td valign=\"top\" halign=\"left\">".$href_menu_name."&nbsp;&nbsp;&nbsp;&nbsp;"
	      .$href_thumbs."<br>".$rs->fields["CATEGORY_DESC"]."</td>";

    /* Following section displays modern examples if there are any */
    $sql_mod = "SELECT IMAGE_LOC FROM MODERN_EXAMPLES WHERE MENU_ID = '" . $rs->fields["MENU_ID"]. "' AND CATEGORY_ID = '".$rs->fields["CATEGORY_ID"]."' ORDER BY IMAGE_NBR";
    $mod_rs = $db->Execute($sql_mod);  /* Note $mod_rs, for modern examples */
    $mod_count = 1;
    while (!$mod_rs->EOF && $mod_count <= 3) {
	  $mod_image = ereg_replace(" ", "%20", $mod_rs->fields["IMAGE_LOC"]);
      print "<td valign=\"top\" halign=\"left\"><img border=\"0\" src=\"" . $mod_image . "\"></a></td>";     
      $mod_count++;
      $mod_rs->MoveNext();
	}
	for ($row_count=1; $row_count <= 3; $row_count++ ) {
      print "<td></td>";     
	}

	print "</tr>";
	
    $rs->MoveNext();
  }
  print "</table>";

}

/****************************************************************************/
include ("./include/footer.php");

?>

</body>
</html>
