<?php
/***********************************************************************************
*  search_results.php                        Wagner Database Solutions, Inc.
*    v1.02 - 26 August 2004  (c) 2004 Steve Wagner.  All rights reserved.
*           See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  Called from search.php to validate and displays the search results
*                based on the user entered criteria.
* 
*  Change Log:
*    v1.0   Initial beta release. (3/4/2004)
*    v1.01  Added $table_background_color variable (5/7/04)
*    v1.02  Added use of specimen_nbr passed parameter. (8/26/04)
*
************************************************************************************/
session_cache_limiter("public"); 
include_once ("./include/config.php");
include_once ("./include/header.php");
?>

<html>
<body>

<?php

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver); 
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

print "<center><b><font class=pch>Search Results</font></b></center><br>";

// Concat all vars together to see if they entered any criteria at all.
$all_vars = $HTTP_POST_VARS [FAMILY] . $HTTP_POST_VARS [GENUS] . $HTTP_POST_VARS [SPECIES] .
  $HTTP_POST_VARS [ORGAN] . $HTTP_POST_VARS [HIGHER_TAXON] . $HTTP_POST_VARS [AUTHOR] .
  $HTTP_POST_VARS [MORPHOTYPE_NBR] . $HTTP_POST_VARS [SPECIMEN_NBR] . $HTTP_POST_VARS [COLLECTION_ID];

if ( $all_vars == '' ) {
  print "<center><b><br>You did not entered any search criteria.  Press the BACK button to enter your search criteria.</b></center><BR>";
  exit;
}

/***********************************************************************************/
// Build the SQL statement from the criteria entered on the search form.  The basic
// Select statement is built.  Then, WHERE clause lines are added depending on 
// what criteria was entered.
					
$query_final="SELECT MORPHOTYPES.FAMILY, MORPHOTYPES.GENUS_NAME, MORPHOTYPES.SPECIES_NAME, 
              SPECIMENS.ORGAN, MORPHOTYPES.HIGHER_TAXON, MORPHOTYPES.AUTHOR, 
			  MORPHOTYPES.MORPHOTYPE_NBR, SPECIMENS.SPECIMEN_NBR, SPECIMENS.COLLECTION_ID,
			  SPECIMENS.SPECIMEN_CAT, IMAGES.IMAGE_TYPE, IMAGES.IMAGE_LOC
	     FROM MORPHOTYPES, SPECIMENS, IMAGES
        WHERE MORPHOTYPES.MORPHOTYPE_NBR = SPECIMENS.MORPHOTYPE_NBR AND
              SPECIMENS.MORPHOTYPE_NBR = IMAGES.MORPHOTYPE_NBR AND
              SPECIMENS.SPECIMEN_NBR = IMAGES.SPECIMEN_NBR AND
		      IMAGES.IMAGE_TYPE = 'T' ";

//  build rest of WHERE clause based on criteria provided.
if ( $HTTP_POST_VARS [FAMILY] ) { 
  $query_final.="and MORPHOTYPES.FAMILY like \"%" . $HTTP_POST_VARS [FAMILY] . "%\" ";
}
if ( $HTTP_POST_VARS [GENUS] ) {
  $query_final.="and MORPHOTYPES.GENUS_NAME like \"%" . $HTTP_POST_VARS [GENUS] . "%\" ";
}
if ( $HTTP_POST_VARS [SPECIES] ) {
  $query_final.="and MORPHOTYPES.SPECIES_NAME like \"%" . $HTTP_POST_VARS [SPECIES] . "%\" ";
}
if ( $HTTP_POST_VARS [ORGAN] ) {
  $query_final.="and SPECIMENS.ORGAN = '" . stripslashes($HTTP_POST_VARS [ORGAN]) . "' ";
}
if ( $HTTP_POST_VARS [HIGHER_TAXON] ) {
  $query_final.="and MORPHOTYPES.HIGHER_TAXON = \"" . $HTTP_POST_VARS [HIGHER_TAXON] . "\" ";
}
if ( $HTTP_POST_VARS [AUTHOR] ) { 
  $query_final.="and MORPHOTYPES.AUTHOR like \"%" . $HTTP_POST_VARS [AUTHOR] . "%\" ";
}
if ( $HTTP_POST_VARS [MORPHOTYPE_NBR] ) {
  $query_final.="and MORPHOTYPES.MORPHOTYPE_NBR like \"%" . $HTTP_POST_VARS [MORPHOTYPE_NBR] . "%\" ";
}
if ( $HTTP_POST_VARS [SPECIMEN_NBR] ) {
  $query_final.="and SPECIMENS.SPECIMEN_NBR like \"%" . $HTTP_POST_VARS [SPECIMEN_NBR] . "%\" ";
}
if ( $HTTP_POST_VARS [COLLECTION_ID] ) {
  $query_final.="and SPECIMENS.COLLECTION_ID = \"" . $HTTP_POST_VARS [COLLECTION_ID] . "\" ";
}

// finish the query with an order by morphotype_nbr
$query_final.=" order by MORPHOTYPES.MORPHOTYPE_NBR;";
//print "sql: " . $query_final . "<BR><BR>";

$rs_final = $db->Execute($query_final);

if ($rs_final->EOF) {
  print "<br><b>No records returned.</b><br>";

} else {

  $recs_found = 0;
  $final_select_list = "<select size=\"1\" name=\"FINAL\" >";
  /* Fetch & display them in a table */
  print "<table  bgcolor=".$table_background_color." WIDTH=\"80%\" align=\"center\" border=\"0\" cellpadding=\"5\"  class=\"results\">";

  print "<tr>";
  $i = 0;

  while (!$rs_final->EOF) {

     $recs_found++;

     print "<td valign=\"top\" halign=\"left\">
            <a href=details.php?morphotype_nbr=".$rs_final->fields["MORPHOTYPE_NBR"]. 
			"&specimen_cat=".$rs_final->fields["SPECIMEN_CAT"]."&specimen_nbr=".str_replace(' ', '%20', $rs_final->fields["SPECIMEN_NBR"])."><img border=\"2\" src="
			.$rs_final->fields["IMAGE_LOC"]."></a><br>"; 
     print "<a href=details.php?morphotype_nbr=".$rs_final->fields["MORPHOTYPE_NBR"].
           "&specimen_cat=".$rs_final->fields["SPECIMEN_CAT"]."&specimen_nbr=".str_replace(' ', '%20', $rs_final->fields["SPECIMEN_NBR"]).">"
           .$rs_final->fields["MORPHOTYPE_NBR"]."</a><br><i>".$rs_final->fields["GENUS_NAME"]."
           ".$rs_final->fields["SPECIES_NAME"]."</i></td>";

     $i = $i+1;

     if ($i == 5) {
        $i = 0;
        print "</tr>";
        print "<tr>";
     }

     $rs_final->MoveNext();
  }

  print "</tr>";
  print "</table>";

}

$sp = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
print "<hr align=\"center\" width=\"95%\" size=\"1\" noshade>";
print "<br>$sp Your Search Found <b>" . $recs_found . "</b> specimen(s).<br><br>";

print "$sp <b>Your Search Criteria<br></b>";
$sp .= "&nbsp;&nbsp;";
print "$sp Family: <b>" . $HTTP_POST_VARS [FAMILY] . "</b><BR>";
print "$sp Genus: <b>" . $HTTP_POST_VARS [GENUS] . "</b><BR>";
print "$sp Species: <b>" . $HTTP_POST_VARS [SPECIES] . "</b><BR>";
print "$sp Organ: <b>" . stripslashes($HTTP_POST_VARS [ORGAN]) . "</b><BR>";
print "$sp Higher Taxon: <b>" . $HTTP_POST_VARS [HIGHER_TAXON] . "</b><BR>";
print "$sp Author: <b>" . $HTTP_POST_VARS [AUTHOR] . "</b><BR>";
print "$sp Morphotype Nbr: <b>" . $HTTP_POST_VARS [MORPHOTYPE_NBR] . "</b><BR>";
print "$sp Specimen Nbr: <b>" . $HTTP_POST_VARS [SPECIMEN_NBR] . "</b><BR>";
print "$sp Collection ID: <b>" . $HTTP_POST_VARS [COLLECTION_ID] . "</b>";

// print "<br><br><b>Query: </b><br>" . $query_final . "<br>";
/*************************************************************************/
?>
<?php

include ("./include/footer.php");

?>

</body>
</html>
