<?php
/***********************************************************************************
*  sumittal_mail.php                         Wagner Database Solutions, Inc.
*    v1.05 - 4 Sep 2004  (c) 2004 Steve Wagner.  All rights reserved.
*
*  Description:  This script sends an email with binary images of JPG or GIF image
*                types.  It is called from submittal.php.  It sends the submittal 
*                emails to the addresses in the include/config.php file to project
*                personnel.
*
*  Change Log:
*    v1.0   Initial beta release
*    v1.01  Variations on libmail.php class.
*    v1.02  Switch to phpmailer.php class, 2/9/04
*    v1.03  Added check for $attachments_ok (Windows/Cisco firewalls vs. open system).
*           Added print of mailer error ($mail->ErrorInfo), 2/9/04
*    v1.04  Added $home_on_drive, 2/18/04
*    v1.05  Added GIF & JPG to criteria for gif & jpg.
*
************************************************************************************/
include_once ("./include/config.php");
include_once ("./include/header.php");
?>

<html>
<body>

<?php
include_once ("phpmailer/class.phpmailer.php");

// check for all required fields
if (($MYNAME == "") || ($EMAIL1 == "") || ($EMAIL2 == "") || ($EMAIL1 != $EMAIL2) ) {
  print "<form name=form method=post action=submittal.php enctype=\"multipart/form-data\">";
  print "<p>Please correct the following errors...</p>";
  if ($MYNAME == "") {print ("<b>&nbsp;* Name is blank.</b><br>");}
  if ($EMAIL1 == "") {print ("<b>&nbsp;* Email1 is blank.</b><br>");}
  if ($EMAIL2 == "") {print ("<b>&nbsp;* Email2 is blank.</b><br>");}
  if ($EMAIL1 != $EMAIL2) {print ("<b>&nbsp;* Email1 ($EMAIL1) and Email2 ($EMAIL2) do not match.</b><br>");}
  print "<p>Press the \"BACK\" button to return...</p>";
  print "</form>";
} else {

  // Process the submittal
  $uploadfile1 = $home_on_drive . $uploaddir . $_FILES['FOSSIL1']['name'];
  $uploadfile2 = $home_on_drive . $uploaddir . $_FILES['FOSSIL2']['name'];
  $moved1 = 0;
  $moved2 = 0;

  $image1_type = preg_replace('/^.*\.(.*?)$/', '\1', $FOSSIL1_name); 
  $image2_type = preg_replace('/^.*\.(.*?)$/', '\1', $FOSSIL2_name); 

  if ($FOSSIL1_name != 'none' and $FOSSIL1_name != '' ) {
    if ( $image1_type == "gif" or $image1_type == "GIF" or $image1_type == "jpg" or $image1_type == "JPG" ) {
      if ( ! move_uploaded_file($_FILES['FOSSIL1']['tmp_name'], $uploadfile1 ) ) {
        $move_error = 1;
        print "Error uploading file: File1 Error: " . $_FILES['FOSSIL1']['error']. "<br>";
      } else {
        $moved1 = 1;
      }
    } else {
	    print "<b>ERROR:</b>  JPGs or GIFs only please.<br>File 1: <b>" . $FOSSIL1_name .
		      "</b> is a <b>" . $image1_type . "</b> file type.<br>";
		$image_error = 1;
    }
  }
  if ($FOSSIL2_name != 'none' and $FOSSIL2_name != '' ) {
    if ( $image2_type == "gif" or $image2_type == "GIF" or $image2_type == "jpg" or $image2_type == "JPG" ) {
      if ( ! move_uploaded_file($_FILES['FOSSIL2']['tmp_name'], $uploadfile2 ) ) {
        $move_error = 1;
        print "Error uploading file: File2 Error: " . $_FILES['FOSSIL2']['error']. "<br>";
      } else {
	    $moved2 = 1;
      }
    } else {
	    print "<b>ERROR:</b>  JPGs or GIFs only please.<br>File 2: <b>" . $FOSSIL2_name .
		      "</b> is a <b>" . $image2_type . "</b> file type.<br>";
		$image_error = 1;
    }
  }

  if ($move_error) {
    print "<br>Error Codes:<br>";
    print " 1; The uploaded file exceeds the upload_max_filesize directive in php.ini.<br>";
    print " 2; The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the html form.<br>";
    print " 3; The uploaded file was only partially uploaded.<br>";
    print " 4; No file was uploaded.<br><br>";
  } elseif ( $image_error ) {
    print "Cannot upload non-image files.<br>Press \"BACK\" button and re-enter image file(s).";
  } else {
    $HTTP_POST_VARS ['REASON'] = stripslashes($HTTP_POST_VARS ['REASON']);

    global $global_vars;
    global $INCLUDE_DIR;

    $mail = new PHPMailer();
    $mail->Encoding = "8bit";
    $mail->CharSet = "iso-8859-1";
    $mail->From = "$EMAIL1";
    $mail->FromName = "$MYNAME";
    $mail->AddAddress("$submittal_email_addresses", "PaleoCollaborator");   // Use:  $submittal_email_addresses
    $mail->Subject = "PaleoCollaborator Submittal";
    //**********************************************
    if ($attachments_ok ) {  // attachments work in this environment.  $attachments_ok is 1.
      $mail->Body = "Name: $MYNAME\nPhone: $CONTACT_PHONE\nInstitution: $INSTITUTION\nImage 1: $FOSSIL1_name\nImage 2: $FOSSIL2_name\nReason:" . $HTTP_POST_VARS ['REASON'] . "\nAddress: $ADDRESS\nCity: $CITY\nState: $STATE1\nZip: $ZIP_CODE\nCountry: $COUNTRY\nEmail: $EMAIL1\nLocation Found: $LOC\nLand Owner: $OWNER\nCounty: $COUNTY\nState: $STATE2\n";
      $mail->SMTPAuth = false;
 
      if ( $moved1 ) {
        $mail->AddAttachment( $uploadfile1 );
      } else {
        $nofile1 = 1;
      }
      if ( $moved2 ) {
        $mail->AddAttachment( $uploadfile2 );  // optional name
      } else {
        $nofile2 = 1;
      }
    //***********************************************
    } else { // Attachments don't work!!!  $attachments_ok is 0.
       $theBody  = "Name: $MYNAME\nPhone: $CONTACT_PHONE\nInstitution: $INSTITUTION\n";
       if ( $moved1 ) {
         $theBody .= "Image 1: http://" . $_SERVER["SERVER_NAME"] . "/" . $uploaddir . "/" . $_FILES['FOSSIL1']['name'] . "\n";
       }
       if ( $moved2 ) {
         $theBody .= "Image 2: http://" . $_SERVER["SERVER_NAME"] . "/" . $uploaddir . "/" . $_FILES['FOSSIL2']['name'] . "\n";
       }
       $theBody .= "Reason:" . $HTTP_POST_VARS ['REASON'];
       $theBody .= "\nAddress: $ADDRESS\nCity: $CITY\nState: $STATE1\nZip: $ZIP_CODE\nCountry: $COUNTRY\n";
       $theBody .= "Email: $EMAIL1\nLocation Found: $LOC\nLand Owner: $OWNER\nCounty: $COUNTY\nState: $STATE2\n";
       $mail->Body = $theBody;
    }
	
    if(!$mail->Send())
    {
      echo "There was an error sending the message. <p>";
      echo "Mailer Error: " . $mail->ErrorInfo;
      exit;
    }

    print "<p><b>$MYNAME</b>,<br><br> Thank you for participating in this project and for your submittal.&nbsp;&nbsp;";
    print "We will review your submittal and respond to you at <b>$EMAIL1</b> as soon as possible.  You may want to print this page for future reference.</p>";
    print "************************************************<br>";
    print "The following information was included in your submittal:</p>";
    print "<b>Name:</b> " . $HTTP_POST_VARS ['MYNAME'] . "<br>";
    print "<b>Phone:</b> " . $HTTP_POST_VARS ['CONTACT_PHONE'] . "<br>";
    print "<b>Institution:</b> " . $HTTP_POST_VARS ['INSTITUTION'] . "<br>";
    print "<b>File1:</b> ";
    if ( $moved1 ) {
      print " " . $FOSSIL1_name . "<br>";
    } else {
	  print " (No file1 attached)<BR>";
	}
    print "<b>File2:</b> ";
    if ( $moved2 ) {
      print " " . $FOSSIL2_name . "<br>";
    } else {
	  print " (No file2 attached)<BR>";
    }
    print "<b>Reason:</b> " . $HTTP_POST_VARS ['REASON'] . "<br>"; 
    print "<b>Address:</b> " . $HTTP_POST_VARS ['ADDRESS'] . "<br>"; 
    print "<b>City:</b> " . $HTTP_POST_VARS ['CITY'] . "<br>"; 
    print "<b>State:</b> " . $HTTP_POST_VARS ['STATE1'] . "<br>";
    print "<b>Zip Code:</b> "  . $HTTP_POST_VARS ['ZIP_CODE'] . "<br>";
    print "<b>County:</b> " . $HTTP_POST_VARS ['COUNTRY'] . "<br>"; 
    print "<b>Email:</b> " . $HTTP_POST_VARS ['EMAIL1'] . "<br>"; 
    print "<b>General Location Found:</b> " . $HTTP_POST_VARS ['LOC'] . "<br>"; 
    print "<b>Land Owner:</b> " . $HTTP_POST_VARS ['OWNER'] . "<br>"; 
    print "<b>Land Owner Cty:</b> " . $HTTP_POST_VARS ['COUNTY'] . "<br>";
    print "<b>Land Owner State:</b> " . $HTTP_POST_VARS ['STATE2'] . "<br>"; 
    print "<br>************************************************<br>";
    echo "<br><b>Message was sent successfully.</b>";

   }
}

?>

</body>
</html>