<?php
/***********************************************************************************
*  thumbs.php                        Wagner Database Solutions, Inc.
*    v1.05 - 26 August 2004  (c) 2004 Steve Wagner.  All rights reserved.
*            See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  This script displays the thumbnail page for images select in the
*                Identification Flow Chart (menu.php).  It can be called in single
*                category_id mode or in "Show All" mode.
*
*  Change Log:
*    v1.0   Initial beta release
*    v1.01  Added "Show All" functionality.
*    v1.02  Changed error message from "No morphotypes found in this category" to
*           "No morphotypes have yet been found at this locality which match these criteria."
*    v1.03  Added "Click on a thumbnail image". (2/27/2004)
*    v1.04  Added $table_background_color variable. (5/7/04)
*    v1.05  Added use of specimen_nbr passed parameter. (8/26/04)
*
************************************************************************************/
include_once ("./include/config.php");
include_once ("./include/header.php");
?>

<html>
<body>

<?php
$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver); 
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

if ($category_id =='') {
  print "<br><b>Error: $category_id category id not found!</b><br>";
} else {
  print "<center><b><font class=pch>Index of Selected Specimens</font></b></center><br>";
}

print "<center><b>Click on a thumbnail image to see more information about the morphotype/specimen.<BR><BR></b></center>";


if ($category_id == "ATTACH") {
  $spec_cat = 'A';
} elseif ($query == "show_all") { 
  $spec_cat = 'H';
} else {
  $spec_cat = 'H';
}
					
if ($query != "show_all") {   // It is NOT show all
  $sql_query = "SELECT MORPHOTYPES.MORPHOTYPE_NBR, MORPHOTYPES.GENUS_NAME, MORPHOTYPES.SPECIES_NAME,
                       SPECIMENS.SPECIMEN_NBR, IMAGES.IMAGE_TYPE, IMAGES.IMAGE_LOC, 
                       MORPHOTYPE_CATEGORIES.CATEGORY_ID
                  FROM MORPHOTYPES, SPECIMENS, IMAGES, MORPHOTYPE_CATEGORIES
                 WHERE MORPHOTYPES.MORPHOTYPE_NBR = SPECIMENS.MORPHOTYPE_NBR AND
                       SPECIMENS.MORPHOTYPE_NBR = IMAGES.MORPHOTYPE_NBR AND
                       SPECIMENS.SPECIMEN_NBR = IMAGES.SPECIMEN_NBR AND
                       SPECIMENS.SPECIMEN_CAT = '$spec_cat' AND
                       MORPHOTYPE_CATEGORIES.MORPHOTYPE_NBR = MORPHOTYPES.MORPHOTYPE_NBR AND
                       MORPHOTYPE_CATEGORIES.CATEGORY_ID = '$category_id' AND
                       MORPHOTYPES.APPROVED_FOR_DISPLAY = 'Y' AND
                       SPECIMENS.APPROVED_FOR_DISPLAY = 'Y' AND
                       IMAGES.IMAGE_TYPE = 'T'
              ORDER BY MORPHOTYPES.MORPHOTYPE_NBR;";
  $rs = $db->Execute( $sql_query );
					
  if ($rs->EOF) {
    print "<form><br><b>No morphotypes have yet been found at this locality which match these criteria.</b>&nbsp;&nbsp;&nbsp;";
    print "<input type=\"button\" value=\"GO BACK\" onClick=\"window.history.go(-1)\"><br>[$category_id]</form>";
  } else {
    /* Fetch & display them in a table */
    print "<table  bgcolor=".$table_background_color." WIDTH=\"80%\" align=\"center\" border=\"0\" cellpadding=\"5\"  class=\"results\">";
    print "<tr>";
    $i = 0;
    while (!$rs->EOF) {
       print "<td valign=\"top\" halign=\"left\">
              <a href=details.php?morphotype_nbr=".$rs->fields["MORPHOTYPE_NBR"].
			  "&specimen_cat=" . $spec_cat . "&specimen_nbr=".str_replace(' ', '%20', $rs->fields["SPECIMEN_NBR"]). "><img border=\"2\" src=".
			  $rs->fields["IMAGE_LOC"]."></a><br>"; 
       print "<a href=details.php?morphotype_nbr=".$rs->fields["MORPHOTYPE_NBR"].
	         "&specimen_cat=" . $spec_cat . "&specimen_nbr=".str_replace(' ', '%20', $rs->fields["SPECIMEN_NBR"]). ">"
             .$rs->fields["MORPHOTYPE_NBR"]."</a><br><i>".$rs->fields["GENUS_NAME"]."
             ".$rs->fields["SPECIES_NAME"]."</i></td>";
 
       $i = $i+1;
       if ($i == 5) {
          $i = 0;
          print "</tr><tr>";
       }
       $rs->MoveNext();
    }
    print "</tr></table>";
  }

} else {   // doing "Show All""

  $arr_i = 0;
  $index = 0;
  $found = 0;
  $orig_category_id = $category_id;  // save original category
  $category_array = array();
  while ( $category_id != '' ) {
    $sql_query = "SELECT MORPHOTYPES.MORPHOTYPE_NBR, MORPHOTYPES.GENUS_NAME, MORPHOTYPES.SPECIES_NAME,
                         SPECIMENS.SPECIMEN_NBR, IMAGES.IMAGE_TYPE, IMAGES.IMAGE_LOC, 
                         MORPHOTYPE_CATEGORIES.CATEGORY_ID
                    FROM MORPHOTYPES, SPECIMENS, IMAGES, MORPHOTYPE_CATEGORIES
                   WHERE MORPHOTYPES.MORPHOTYPE_NBR = SPECIMENS.MORPHOTYPE_NBR AND
                         SPECIMENS.MORPHOTYPE_NBR = IMAGES.MORPHOTYPE_NBR AND
                         SPECIMENS.SPECIMEN_NBR = IMAGES.SPECIMEN_NBR AND
                         SPECIMENS.SPECIMEN_CAT = '$spec_cat' AND
                         MORPHOTYPE_CATEGORIES.MORPHOTYPE_NBR = MORPHOTYPES.MORPHOTYPE_NBR AND
                         MORPHOTYPE_CATEGORIES.CATEGORY_ID = '$category_id' AND
                         MORPHOTYPES.APPROVED_FOR_DISPLAY = 'Y' AND
	                     SPECIMENS.APPROVED_FOR_DISPLAY = 'Y' AND
                         IMAGES.IMAGE_TYPE = 'T'
                ORDER BY MORPHOTYPES.MORPHOTYPE_NBR;";
    $rsa = $db->Execute( $sql_query );
					
    if (!$rsa->EOF) {
      $found = 1;  // at least one found, set flag for later use.
	  /* Fetch & display them in a table */
      print "<hr><BR>&nbsp;&nbsp;Show All category: " . $category_id . "<BR><br>" ;
      print "<table  bgcolor=".$table_background_color." WIDTH=\"80%\" align=\"center\" border=\"0\" cellpadding=\"5\"  class=\"results\">";
      print "<tr>";
      $i = 0;
      while (!$rsa->EOF) {
        print "<td valign=\"top\" halign=\"left\">
               <a href=details.php?morphotype_nbr=".$rsa->fields["MORPHOTYPE_NBR"]."&specimen_cat=" . $spec_cat . 
			   "&specimen_nbr=".str_replace(' ', '%20', $rsa->fields["SPECIMEN_NBR"]).">
               <img border=\"2\" src=".$rsa->fields["IMAGE_LOC"]."></a><br>"; 
        print "<a href=details.php?morphotype_nbr=".$rsa->fields["MORPHOTYPE_NBR"]."&specimen_cat=" . $spec_cat . 
		       "&specimen_nbr=".str_replace(' ', '%20', $rsa->fields["SPECIMEN_NBR"]).">"
              .$rsa->fields["MORPHOTYPE_NBR"]."</a><br><i>".$rsa->fields["GENUS_NAME"]."
              ".$rsa->fields["SPECIES_NAME"]."</i></td>";

        $i = $i+1;
        if ($i == 5) {
          $i = 0;
          print "</tr><tr>";
        }
        $rsa->MoveNext();
      }
      print "</tr></table>";
    }

    //******  Get list of next lower category level in the tree *****************
    $rs_cat = $db->Execute ("SELECT CATEGORY_ID from CATEGORIES where MENU_ID = '$category_id';");

    while (!$rs_cat->EOF) {
      // [for debugging] print "rs_cat: " . $rs_cat->fields["CATEGORY_ID"] . "<br>";
      $category_array[$arr_i] = $rs_cat->fields["CATEGORY_ID"];
      $rs_cat->MoveNext();
      $arr_i = $arr_i+1;
    }
	$category_id = $category_array[$index];
	$index = $index+1;	
  }
  if ( $found == '0' ) {  // didn't find any doing "Show All".
    print "<form><br><b>No morphotypes have yet been found at this locality which match these criteria.</b>&nbsp;&nbsp;&nbsp;";
    print "<input type=\"button\" value=\"GO BACK\" onClick=\"window.history.go(-1)\"><br>[$orig_category_id]</form>";
  }
}
/****************************************************************************/

include ("./include/footer.php");

?>

</body>
</html>