<?php
/***********************************************************************************
*  thumbs_match.php                        Wagner Database Solutions, Inc.
*    v1.02 - 26 August 2004  (c) 2004 Steve Wagner.  All rights reserved.
*           See the PaleoCollaborator License included as license_v1.x.txt
*
*  Description:  This script is very similar to thumbs.php except that it finds close
*                matches to the morphotypes.  It is called from details.php when the
*                user clicks the link "View other specimens of this morphotype".
*
*  Change Log:
*    v1.0   Initial beta release
*    v1.01  Added $table_background_color (5/7/04)
*    v1.02  Added use of specimen_nbr passed parameter. (8/26/04)
*
************************************************************************************/
include_once ("./include/config.php");
include_once ("./include/header.php");
?>
<html>
<body>

<?php

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$db = ADONewConnection($driver); 
/* $db->debug = true;  #true */
$db->Connect($server, $user, $password, $database);

if ($morph_match =='') {
  print "<br><b>Error: No morphotype number passed.</b><br>";
} else {
  print "<center><b><font class=pch>Other Specimens of Morphotype $morph_match</font></b></center><br>";
}

$sql = "SELECT MORPHOTYPES.MORPHOTYPE_NBR, MORPHOTYPES.GENUS_NAME, MORPHOTYPES.SPECIES_NAME,
                           SPECIMENS.SPECIMEN_NBR, SPECIMENS.SPECIMEN_CAT, IMAGES.IMAGE_TYPE, IMAGES.IMAGE_LOC 
                    FROM MORPHOTYPES, SPECIMENS, IMAGES
                   WHERE MORPHOTYPES.MORPHOTYPE_NBR = SPECIMENS.MORPHOTYPE_NBR AND
                          SPECIMENS.MORPHOTYPE_NBR = IMAGES.MORPHOTYPE_NBR AND
						  SPECIMENS.SPECIMEN_NBR = IMAGES.SPECIMEN_NBR AND
                          SPECIMENS.SPECIMEN_CAT != 'H' AND
						  MORPHOTYPES.MORPHOTYPE_NBR LIKE '%$morph_match%' AND
  						  MORPHOTYPES.APPROVED_FOR_DISPLAY = 'Y' AND
  						  SPECIMENS.APPROVED_FOR_DISPLAY = 'Y' AND
						  IMAGES.IMAGE_TYPE = 'T' 
                    ORDER BY MORPHOTYPES.MORPHOTYPE_NBR, SPECIMENS.SPECIMEN_NBR;";

$rs = $db->Execute($sql);

if ($rs->EOF) {
  print "<form><br><b>No other specimens of this morphotype $morph_match found.</b>&nbsp;&nbsp;&nbsp;";
  print "<input type=\"button\" value=\"GO BACK\" onClick=\"window.history.go(-1)\"><br>[$category_id]</form>";
} else {

  /* Fetch & display them in a table */
  print "<table  bgcolor=".$table_background_color." WIDTH=\"80%\" align=\"center\" border=\"0\" cellpadding=\"5\"  class=\"results\">";

  print "<tr>";
  $i = 0;
  while (!$rs->EOF) {

     print "<td valign=\"top\" halign=\"left\">
            <a href=details.php?morphotype_nbr=".$rs->fields["MORPHOTYPE_NBR"].
			"&specimen_cat=" . $rs->fields["SPECIMEN_CAT"] . "&specimen_nbr=".str_replace(' ', '%20', $rs->fields["SPECIMEN_NBR"])."><img border=\"2\" src=".
			$rs->fields["IMAGE_LOC"]."></a><br>"; 
     print "<a href=details.php?morphotype_nbr=".$rs->fields["MORPHOTYPE_NBR"].
	        "&specimen_cat=" . $rs->fields["SPECIMEN_CAT"] . "&specimen_nbr=".str_replace(' ', '%20', $rs->fields["SPECIMEN_NBR"]).">"
           .$rs->fields["MORPHOTYPE_NBR"]."</a><br><i>".$rs->fields["GENUS_NAME"]."
           ".$rs->fields["SPECIES_NAME"]."</i></td>";

     $i = $i+1;

     if ($i == 5) {
        $i = 0;
        print "</tr>";
        print "<tr>";
     }

     $rs->MoveNext();
  }

  print "</tr>";
  print "</table>";
}

/****************************************************************************/

include ("./include/footer.php");

?>

</body>
</html>
